<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/analytics/data/v1alpha/data.proto

namespace Google\Analytics\Data\V1alpha;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An expression to filter dimension or metric values.
 *
 * Generated from protobuf message <code>google.analytics.data.v1alpha.Filter</code>
 */
class Filter extends \Google\Protobuf\Internal\Message
{
    /**
     * The dimension name or metric name. Must be a name defined in dimensions
     * or metrics.
     *
     * Generated from protobuf field <code>string field_name = 1;</code>
     */
    private $field_name = '';
    protected $one_filter;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $field_name
     *           The dimension name or metric name. Must be a name defined in dimensions
     *           or metrics.
     *     @type bool $null_filter
     *           A filter for null values. If True, a null dimension value is matched by
     *           this filter. Null filter is commonly used inside a NOT filter
     *           expression. For example, a NOT expression of a null filter removes rows
     *           when a dimension is null.
     *     @type \Google\Analytics\Data\V1alpha\Filter\StringFilter $string_filter
     *           Strings related filter.
     *     @type \Google\Analytics\Data\V1alpha\Filter\InListFilter $in_list_filter
     *           A filter for in list values.
     *     @type \Google\Analytics\Data\V1alpha\Filter\NumericFilter $numeric_filter
     *           A filter for numeric or date values.
     *     @type \Google\Analytics\Data\V1alpha\Filter\BetweenFilter $between_filter
     *           A filter for two values.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Analytics\Data\V1Alpha\Data::initOnce();
        parent::__construct($data);
    }

    /**
     * The dimension name or metric name. Must be a name defined in dimensions
     * or metrics.
     *
     * Generated from protobuf field <code>string field_name = 1;</code>
     * @return string
     */
    public function getFieldName()
    {
        return $this->field_name;
    }

    /**
     * The dimension name or metric name. Must be a name defined in dimensions
     * or metrics.
     *
     * Generated from protobuf field <code>string field_name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setFieldName($var)
    {
        GPBUtil::checkString($var, True);
        $this->field_name = $var;

        return $this;
    }

    /**
     * A filter for null values. If True, a null dimension value is matched by
     * this filter. Null filter is commonly used inside a NOT filter
     * expression. For example, a NOT expression of a null filter removes rows
     * when a dimension is null.
     *
     * Generated from protobuf field <code>bool null_filter = 2;</code>
     * @return bool
     */
    public function getNullFilter()
    {
        return $this->readOneof(2);
    }

    public function hasNullFilter()
    {
        return $this->hasOneof(2);
    }

    /**
     * A filter for null values. If True, a null dimension value is matched by
     * this filter. Null filter is commonly used inside a NOT filter
     * expression. For example, a NOT expression of a null filter removes rows
     * when a dimension is null.
     *
     * Generated from protobuf field <code>bool null_filter = 2;</code>
     * @param bool $var
     * @return $this
     */
    public function setNullFilter($var)
    {
        GPBUtil::checkBool($var);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * Strings related filter.
     *
     * Generated from protobuf field <code>.google.analytics.data.v1alpha.Filter.StringFilter string_filter = 3;</code>
     * @return \Google\Analytics\Data\V1alpha\Filter\StringFilter
     */
    public function getStringFilter()
    {
        return $this->readOneof(3);
    }

    public function hasStringFilter()
    {
        return $this->hasOneof(3);
    }

    /**
     * Strings related filter.
     *
     * Generated from protobuf field <code>.google.analytics.data.v1alpha.Filter.StringFilter string_filter = 3;</code>
     * @param \Google\Analytics\Data\V1alpha\Filter\StringFilter $var
     * @return $this
     */
    public function setStringFilter($var)
    {
        GPBUtil::checkMessage($var, \Google\Analytics\Data\V1alpha\Filter\StringFilter::class);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * A filter for in list values.
     *
     * Generated from protobuf field <code>.google.analytics.data.v1alpha.Filter.InListFilter in_list_filter = 4;</code>
     * @return \Google\Analytics\Data\V1alpha\Filter\InListFilter
     */
    public function getInListFilter()
    {
        return $this->readOneof(4);
    }

    public function hasInListFilter()
    {
        return $this->hasOneof(4);
    }

    /**
     * A filter for in list values.
     *
     * Generated from protobuf field <code>.google.analytics.data.v1alpha.Filter.InListFilter in_list_filter = 4;</code>
     * @param \Google\Analytics\Data\V1alpha\Filter\InListFilter $var
     * @return $this
     */
    public function setInListFilter($var)
    {
        GPBUtil::checkMessage($var, \Google\Analytics\Data\V1alpha\Filter\InListFilter::class);
        $this->writeOneof(4, $var);

        return $this;
    }

    /**
     * A filter for numeric or date values.
     *
     * Generated from protobuf field <code>.google.analytics.data.v1alpha.Filter.NumericFilter numeric_filter = 5;</code>
     * @return \Google\Analytics\Data\V1alpha\Filter\NumericFilter
     */
    public function getNumericFilter()
    {
        return $this->readOneof(5);
    }

    public function hasNumericFilter()
    {
        return $this->hasOneof(5);
    }

    /**
     * A filter for numeric or date values.
     *
     * Generated from protobuf field <code>.google.analytics.data.v1alpha.Filter.NumericFilter numeric_filter = 5;</code>
     * @param \Google\Analytics\Data\V1alpha\Filter\NumericFilter $var
     * @return $this
     */
    public function setNumericFilter($var)
    {
        GPBUtil::checkMessage($var, \Google\Analytics\Data\V1alpha\Filter\NumericFilter::class);
        $this->writeOneof(5, $var);

        return $this;
    }

    /**
     * A filter for two values.
     *
     * Generated from protobuf field <code>.google.analytics.data.v1alpha.Filter.BetweenFilter between_filter = 6;</code>
     * @return \Google\Analytics\Data\V1alpha\Filter\BetweenFilter
     */
    public function getBetweenFilter()
    {
        return $this->readOneof(6);
    }

    public function hasBetweenFilter()
    {
        return $this->hasOneof(6);
    }

    /**
     * A filter for two values.
     *
     * Generated from protobuf field <code>.google.analytics.data.v1alpha.Filter.BetweenFilter between_filter = 6;</code>
     * @param \Google\Analytics\Data\V1alpha\Filter\BetweenFilter $var
     * @return $this
     */
    public function setBetweenFilter($var)
    {
        GPBUtil::checkMessage($var, \Google\Analytics\Data\V1alpha\Filter\BetweenFilter::class);
        $this->writeOneof(6, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getOneFilter()
    {
        return $this->whichOneof("one_filter");
    }

}

