<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/automl/v1beta1/io.proto

namespace Google\Cloud\AutoMl\V1beta1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Output configuration for ExportEvaluatedExamples Action. Note that this call
 * is available only for 30 days since the moment the model was evaluated.
 * The output depends on the domain, as follows (note that only examples from
 * the TEST set are exported):
 *  *  For Tables:
 * [bigquery_destination][google.cloud.automl.v1beta1.OutputConfig.bigquery_destination]
 *       pointing to a BigQuery project must be set. In the given project a
 *       new dataset will be created with name
 * `export_evaluated_examples_<model-display-name>_<timestamp-of-export-call>`
 *       where <model-display-name> will be made BigQuery-dataset-name
 *       compatible (e.g. most special characters will become underscores),
 *       and timestamp will be in YYYY_MM_DDThh_mm_ss_sssZ "based on ISO-8601"
 *       format. In the dataset an `evaluated_examples` table will be
 *       created. It will have all the same columns as the
 * [primary_table][google.cloud.automl.v1beta1.TablesDatasetMetadata.primary_table_spec_id]
 *       of the
 *       [dataset][google.cloud.automl.v1beta1.Model.dataset_id] from which
 *       the model was created, as they were at the moment of model's
 *       evaluation (this includes the target column with its ground
 *       truth), followed by a column called "predicted_<target_column>". That
 *       last column will contain the model's prediction result for each
 *       respective row, given as ARRAY of
 *       [AnnotationPayloads][google.cloud.automl.v1beta1.AnnotationPayload],
 *       represented as STRUCT-s, containing
 *       [TablesAnnotation][google.cloud.automl.v1beta1.TablesAnnotation].
 *
 * Generated from protobuf message <code>google.cloud.automl.v1beta1.ExportEvaluatedExamplesOutputConfig</code>
 */
class ExportEvaluatedExamplesOutputConfig extends \Google\Protobuf\Internal\Message
{
    protected $destination;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Cloud\AutoMl\V1beta1\BigQueryDestination $bigquery_destination
     *           The BigQuery location where the output is to be written to.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Automl\V1Beta1\Io::initOnce();
        parent::__construct($data);
    }

    /**
     * The BigQuery location where the output is to be written to.
     *
     * Generated from protobuf field <code>.google.cloud.automl.v1beta1.BigQueryDestination bigquery_destination = 2;</code>
     * @return \Google\Cloud\AutoMl\V1beta1\BigQueryDestination
     */
    public function getBigqueryDestination()
    {
        return $this->readOneof(2);
    }

    public function hasBigqueryDestination()
    {
        return $this->hasOneof(2);
    }

    /**
     * The BigQuery location where the output is to be written to.
     *
     * Generated from protobuf field <code>.google.cloud.automl.v1beta1.BigQueryDestination bigquery_destination = 2;</code>
     * @param \Google\Cloud\AutoMl\V1beta1\BigQueryDestination $var
     * @return $this
     */
    public function setBigqueryDestination($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\AutoMl\V1beta1\BigQueryDestination::class);
        $this->writeOneof(2, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getDestination()
    {
        return $this->whichOneof("destination");
    }

}

