<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/compute/v1/compute.proto

namespace Google\Cloud\Compute\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An access configuration attached to an instance's network interface. Only one access config per instance is supported.
 *
 * Generated from protobuf message <code>google.cloud.compute.v1.AccessConfig</code>
 */
class AccessConfig extends \Google\Protobuf\Internal\Message
{
    /**
     * [Output Only] Type of the resource. Always compute#accessConfig for access configs.
     *
     * Generated from protobuf field <code>string kind = 3292052;</code>
     */
    private $kind = '';
    /**
     * The name of this access configuration. The default and recommended name is External NAT, but you can use any arbitrary string, such as My external IP or Network Access.
     *
     * Generated from protobuf field <code>string name = 3373707;</code>
     */
    private $name = '';
    /**
     * An external IP address associated with this instance. Specify an unused static external IP address available to the project or leave this field undefined to use an IP from a shared ephemeral IP address pool. If you specify a static external IP address, it must live in the same region as the zone of the instance.
     *
     * Generated from protobuf field <code>string nat_i_p = 117634556;</code>
     */
    private $nat_i_p = '';
    /**
     * This signifies the networking tier used for configuring this access configuration and can only take the following values: PREMIUM, STANDARD.
     * If an AccessConfig is specified without a valid external IP address, an ephemeral IP will be created with this networkTier.
     * If an AccessConfig with a valid external IP address is specified, it must match that of the networkTier associated with the Address resource owning that IP.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.AccessConfig.NetworkTier network_tier = 248962387;</code>
     */
    private $network_tier = 0;
    /**
     * The DNS domain name for the public PTR record. You can set this field only if the `setPublicPtr` field is enabled.
     *
     * Generated from protobuf field <code>string public_ptr_domain_name = 48163711;</code>
     */
    private $public_ptr_domain_name = '';
    /**
     * Specifies whether a public DNS 'PTR' record should be created to map the external IP address of the instance to a DNS domain name.
     *
     * Generated from protobuf field <code>bool set_public_ptr = 255434773;</code>
     */
    private $set_public_ptr = false;
    /**
     * The type of configuration. The default and only option is ONE_TO_ONE_NAT.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.AccessConfig.Type type = 3575610;</code>
     */
    private $type = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $kind
     *           [Output Only] Type of the resource. Always compute#accessConfig for access configs.
     *     @type string $name
     *           The name of this access configuration. The default and recommended name is External NAT, but you can use any arbitrary string, such as My external IP or Network Access.
     *     @type string $nat_i_p
     *           An external IP address associated with this instance. Specify an unused static external IP address available to the project or leave this field undefined to use an IP from a shared ephemeral IP address pool. If you specify a static external IP address, it must live in the same region as the zone of the instance.
     *     @type int $network_tier
     *           This signifies the networking tier used for configuring this access configuration and can only take the following values: PREMIUM, STANDARD.
     *           If an AccessConfig is specified without a valid external IP address, an ephemeral IP will be created with this networkTier.
     *           If an AccessConfig with a valid external IP address is specified, it must match that of the networkTier associated with the Address resource owning that IP.
     *     @type string $public_ptr_domain_name
     *           The DNS domain name for the public PTR record. You can set this field only if the `setPublicPtr` field is enabled.
     *     @type bool $set_public_ptr
     *           Specifies whether a public DNS 'PTR' record should be created to map the external IP address of the instance to a DNS domain name.
     *     @type int $type
     *           The type of configuration. The default and only option is ONE_TO_ONE_NAT.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Compute\V1\Compute::initOnce();
        parent::__construct($data);
    }

    /**
     * [Output Only] Type of the resource. Always compute#accessConfig for access configs.
     *
     * Generated from protobuf field <code>string kind = 3292052;</code>
     * @return string
     */
    public function getKind()
    {
        return $this->kind;
    }

    /**
     * [Output Only] Type of the resource. Always compute#accessConfig for access configs.
     *
     * Generated from protobuf field <code>string kind = 3292052;</code>
     * @param string $var
     * @return $this
     */
    public function setKind($var)
    {
        GPBUtil::checkString($var, True);
        $this->kind = $var;

        return $this;
    }

    /**
     * The name of this access configuration. The default and recommended name is External NAT, but you can use any arbitrary string, such as My external IP or Network Access.
     *
     * Generated from protobuf field <code>string name = 3373707;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * The name of this access configuration. The default and recommended name is External NAT, but you can use any arbitrary string, such as My external IP or Network Access.
     *
     * Generated from protobuf field <code>string name = 3373707;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * An external IP address associated with this instance. Specify an unused static external IP address available to the project or leave this field undefined to use an IP from a shared ephemeral IP address pool. If you specify a static external IP address, it must live in the same region as the zone of the instance.
     *
     * Generated from protobuf field <code>string nat_i_p = 117634556;</code>
     * @return string
     */
    public function getNatIP()
    {
        return $this->nat_i_p;
    }

    /**
     * An external IP address associated with this instance. Specify an unused static external IP address available to the project or leave this field undefined to use an IP from a shared ephemeral IP address pool. If you specify a static external IP address, it must live in the same region as the zone of the instance.
     *
     * Generated from protobuf field <code>string nat_i_p = 117634556;</code>
     * @param string $var
     * @return $this
     */
    public function setNatIP($var)
    {
        GPBUtil::checkString($var, True);
        $this->nat_i_p = $var;

        return $this;
    }

    /**
     * This signifies the networking tier used for configuring this access configuration and can only take the following values: PREMIUM, STANDARD.
     * If an AccessConfig is specified without a valid external IP address, an ephemeral IP will be created with this networkTier.
     * If an AccessConfig with a valid external IP address is specified, it must match that of the networkTier associated with the Address resource owning that IP.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.AccessConfig.NetworkTier network_tier = 248962387;</code>
     * @return int
     */
    public function getNetworkTier()
    {
        return $this->network_tier;
    }

    /**
     * This signifies the networking tier used for configuring this access configuration and can only take the following values: PREMIUM, STANDARD.
     * If an AccessConfig is specified without a valid external IP address, an ephemeral IP will be created with this networkTier.
     * If an AccessConfig with a valid external IP address is specified, it must match that of the networkTier associated with the Address resource owning that IP.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.AccessConfig.NetworkTier network_tier = 248962387;</code>
     * @param int $var
     * @return $this
     */
    public function setNetworkTier($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Compute\V1\AccessConfig\NetworkTier::class);
        $this->network_tier = $var;

        return $this;
    }

    /**
     * The DNS domain name for the public PTR record. You can set this field only if the `setPublicPtr` field is enabled.
     *
     * Generated from protobuf field <code>string public_ptr_domain_name = 48163711;</code>
     * @return string
     */
    public function getPublicPtrDomainName()
    {
        return $this->public_ptr_domain_name;
    }

    /**
     * The DNS domain name for the public PTR record. You can set this field only if the `setPublicPtr` field is enabled.
     *
     * Generated from protobuf field <code>string public_ptr_domain_name = 48163711;</code>
     * @param string $var
     * @return $this
     */
    public function setPublicPtrDomainName($var)
    {
        GPBUtil::checkString($var, True);
        $this->public_ptr_domain_name = $var;

        return $this;
    }

    /**
     * Specifies whether a public DNS 'PTR' record should be created to map the external IP address of the instance to a DNS domain name.
     *
     * Generated from protobuf field <code>bool set_public_ptr = 255434773;</code>
     * @return bool
     */
    public function getSetPublicPtr()
    {
        return $this->set_public_ptr;
    }

    /**
     * Specifies whether a public DNS 'PTR' record should be created to map the external IP address of the instance to a DNS domain name.
     *
     * Generated from protobuf field <code>bool set_public_ptr = 255434773;</code>
     * @param bool $var
     * @return $this
     */
    public function setSetPublicPtr($var)
    {
        GPBUtil::checkBool($var);
        $this->set_public_ptr = $var;

        return $this;
    }

    /**
     * The type of configuration. The default and only option is ONE_TO_ONE_NAT.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.AccessConfig.Type type = 3575610;</code>
     * @return int
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * The type of configuration. The default and only option is ONE_TO_ONE_NAT.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.AccessConfig.Type type = 3575610;</code>
     * @param int $var
     * @return $this
     */
    public function setType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Compute\V1\AccessConfig\Type::class);
        $this->type = $var;

        return $this;
    }

}

