<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/compute/v1/compute.proto

namespace Google\Cloud\Compute\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 *
 * Generated from protobuf message <code>google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy</code>
 */
class InstanceGroupManagerUpdatePolicy extends \Google\Protobuf\Internal\Message
{
    /**
     * The  instance redistribution policy for regional managed instance groups. Valid values are:
     * - PROACTIVE (default): The group attempts to maintain an even distribution of VM instances across zones in the region.
     * - NONE: For non-autoscaled groups, proactive redistribution is disabled.
     *
     * Generated from protobuf field <code>string instance_redistribution_type = 24194968;</code>
     */
    private $instance_redistribution_type = '';
    /**
     * The maximum number of instances that can be created above the specified targetSize during the update process. By default, a fixed value of 1 is used. This value can be either a fixed number or a percentage if the instance group has 10 or more instances. If you set a percentage, the number of instances will be rounded up if necessary.
     * At least one of either maxSurge or maxUnavailable must be greater than 0. Learn more about maxSurge.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.FixedOrPercent max_surge = 34137235;</code>
     */
    private $max_surge = null;
    /**
     * The maximum number of instances that can be unavailable during the update process. An instance is considered available if all of the following conditions are satisfied:
     * - The instance's status is RUNNING.
     * - If there is a health check on the instance group, the instance's liveness health check result must be HEALTHY at least once. If there is no health check on the group, then the instance only needs to have a status of RUNNING to be considered available.  By default, a fixed value of 1 is used. This value can be either a fixed number or a percentage if the instance group has 10 or more instances. If you set a percentage, the number of instances will be rounded up if necessary.
     * At least one of either maxSurge or maxUnavailable must be greater than 0. Learn more about maxUnavailable.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.FixedOrPercent max_unavailable = 136504821;</code>
     */
    private $max_unavailable = null;
    /**
     * Minimal action to be taken on an instance. You can specify either RESTART to restart existing instances or REPLACE to delete and create new instances from the target template. If you specify a RESTART, the Updater will attempt to perform that action only. However, if the Updater determines that the minimal action you specify is not enough to perform the update, it might perform a more disruptive action.
     *
     * Generated from protobuf field <code>string minimal_action = 2131604;</code>
     */
    private $minimal_action = '';
    /**
     * What action should be used to replace instances. See minimal_action.REPLACE
     *
     * Generated from protobuf field <code>string replacement_method = 237496238;</code>
     */
    private $replacement_method = '';
    /**
     * The type of update process. You can specify either PROACTIVE so that the instance group manager proactively executes actions in order to bring instances to their target versions or OPPORTUNISTIC so that no action is proactively executed but the update will be performed as part of other actions (for example, resizes or recreateInstances calls).
     *
     * Generated from protobuf field <code>string type = 3575610;</code>
     */
    private $type = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $instance_redistribution_type
     *           The  instance redistribution policy for regional managed instance groups. Valid values are:
     *           - PROACTIVE (default): The group attempts to maintain an even distribution of VM instances across zones in the region.
     *           - NONE: For non-autoscaled groups, proactive redistribution is disabled.
     *     @type \Google\Cloud\Compute\V1\FixedOrPercent $max_surge
     *           The maximum number of instances that can be created above the specified targetSize during the update process. By default, a fixed value of 1 is used. This value can be either a fixed number or a percentage if the instance group has 10 or more instances. If you set a percentage, the number of instances will be rounded up if necessary.
     *           At least one of either maxSurge or maxUnavailable must be greater than 0. Learn more about maxSurge.
     *     @type \Google\Cloud\Compute\V1\FixedOrPercent $max_unavailable
     *           The maximum number of instances that can be unavailable during the update process. An instance is considered available if all of the following conditions are satisfied:
     *           - The instance's status is RUNNING.
     *           - If there is a health check on the instance group, the instance's liveness health check result must be HEALTHY at least once. If there is no health check on the group, then the instance only needs to have a status of RUNNING to be considered available.  By default, a fixed value of 1 is used. This value can be either a fixed number or a percentage if the instance group has 10 or more instances. If you set a percentage, the number of instances will be rounded up if necessary.
     *           At least one of either maxSurge or maxUnavailable must be greater than 0. Learn more about maxUnavailable.
     *     @type string $minimal_action
     *           Minimal action to be taken on an instance. You can specify either RESTART to restart existing instances or REPLACE to delete and create new instances from the target template. If you specify a RESTART, the Updater will attempt to perform that action only. However, if the Updater determines that the minimal action you specify is not enough to perform the update, it might perform a more disruptive action.
     *     @type string $replacement_method
     *           What action should be used to replace instances. See minimal_action.REPLACE
     *     @type string $type
     *           The type of update process. You can specify either PROACTIVE so that the instance group manager proactively executes actions in order to bring instances to their target versions or OPPORTUNISTIC so that no action is proactively executed but the update will be performed as part of other actions (for example, resizes or recreateInstances calls).
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Compute\V1\Compute::initOnce();
        parent::__construct($data);
    }

    /**
     * The  instance redistribution policy for regional managed instance groups. Valid values are:
     * - PROACTIVE (default): The group attempts to maintain an even distribution of VM instances across zones in the region.
     * - NONE: For non-autoscaled groups, proactive redistribution is disabled.
     *
     * Generated from protobuf field <code>string instance_redistribution_type = 24194968;</code>
     * @return string
     */
    public function getInstanceRedistributionType()
    {
        return $this->instance_redistribution_type;
    }

    /**
     * The  instance redistribution policy for regional managed instance groups. Valid values are:
     * - PROACTIVE (default): The group attempts to maintain an even distribution of VM instances across zones in the region.
     * - NONE: For non-autoscaled groups, proactive redistribution is disabled.
     *
     * Generated from protobuf field <code>string instance_redistribution_type = 24194968;</code>
     * @param string $var
     * @return $this
     */
    public function setInstanceRedistributionType($var)
    {
        GPBUtil::checkString($var, True);
        $this->instance_redistribution_type = $var;

        return $this;
    }

    /**
     * The maximum number of instances that can be created above the specified targetSize during the update process. By default, a fixed value of 1 is used. This value can be either a fixed number or a percentage if the instance group has 10 or more instances. If you set a percentage, the number of instances will be rounded up if necessary.
     * At least one of either maxSurge or maxUnavailable must be greater than 0. Learn more about maxSurge.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.FixedOrPercent max_surge = 34137235;</code>
     * @return \Google\Cloud\Compute\V1\FixedOrPercent
     */
    public function getMaxSurge()
    {
        return isset($this->max_surge) ? $this->max_surge : null;
    }

    public function hasMaxSurge()
    {
        return isset($this->max_surge);
    }

    public function clearMaxSurge()
    {
        unset($this->max_surge);
    }

    /**
     * The maximum number of instances that can be created above the specified targetSize during the update process. By default, a fixed value of 1 is used. This value can be either a fixed number or a percentage if the instance group has 10 or more instances. If you set a percentage, the number of instances will be rounded up if necessary.
     * At least one of either maxSurge or maxUnavailable must be greater than 0. Learn more about maxSurge.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.FixedOrPercent max_surge = 34137235;</code>
     * @param \Google\Cloud\Compute\V1\FixedOrPercent $var
     * @return $this
     */
    public function setMaxSurge($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Compute\V1\FixedOrPercent::class);
        $this->max_surge = $var;

        return $this;
    }

    /**
     * The maximum number of instances that can be unavailable during the update process. An instance is considered available if all of the following conditions are satisfied:
     * - The instance's status is RUNNING.
     * - If there is a health check on the instance group, the instance's liveness health check result must be HEALTHY at least once. If there is no health check on the group, then the instance only needs to have a status of RUNNING to be considered available.  By default, a fixed value of 1 is used. This value can be either a fixed number or a percentage if the instance group has 10 or more instances. If you set a percentage, the number of instances will be rounded up if necessary.
     * At least one of either maxSurge or maxUnavailable must be greater than 0. Learn more about maxUnavailable.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.FixedOrPercent max_unavailable = 136504821;</code>
     * @return \Google\Cloud\Compute\V1\FixedOrPercent
     */
    public function getMaxUnavailable()
    {
        return isset($this->max_unavailable) ? $this->max_unavailable : null;
    }

    public function hasMaxUnavailable()
    {
        return isset($this->max_unavailable);
    }

    public function clearMaxUnavailable()
    {
        unset($this->max_unavailable);
    }

    /**
     * The maximum number of instances that can be unavailable during the update process. An instance is considered available if all of the following conditions are satisfied:
     * - The instance's status is RUNNING.
     * - If there is a health check on the instance group, the instance's liveness health check result must be HEALTHY at least once. If there is no health check on the group, then the instance only needs to have a status of RUNNING to be considered available.  By default, a fixed value of 1 is used. This value can be either a fixed number or a percentage if the instance group has 10 or more instances. If you set a percentage, the number of instances will be rounded up if necessary.
     * At least one of either maxSurge or maxUnavailable must be greater than 0. Learn more about maxUnavailable.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.FixedOrPercent max_unavailable = 136504821;</code>
     * @param \Google\Cloud\Compute\V1\FixedOrPercent $var
     * @return $this
     */
    public function setMaxUnavailable($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Compute\V1\FixedOrPercent::class);
        $this->max_unavailable = $var;

        return $this;
    }

    /**
     * Minimal action to be taken on an instance. You can specify either RESTART to restart existing instances or REPLACE to delete and create new instances from the target template. If you specify a RESTART, the Updater will attempt to perform that action only. However, if the Updater determines that the minimal action you specify is not enough to perform the update, it might perform a more disruptive action.
     *
     * Generated from protobuf field <code>string minimal_action = 2131604;</code>
     * @return string
     */
    public function getMinimalAction()
    {
        return $this->minimal_action;
    }

    /**
     * Minimal action to be taken on an instance. You can specify either RESTART to restart existing instances or REPLACE to delete and create new instances from the target template. If you specify a RESTART, the Updater will attempt to perform that action only. However, if the Updater determines that the minimal action you specify is not enough to perform the update, it might perform a more disruptive action.
     *
     * Generated from protobuf field <code>string minimal_action = 2131604;</code>
     * @param string $var
     * @return $this
     */
    public function setMinimalAction($var)
    {
        GPBUtil::checkString($var, True);
        $this->minimal_action = $var;

        return $this;
    }

    /**
     * What action should be used to replace instances. See minimal_action.REPLACE
     *
     * Generated from protobuf field <code>string replacement_method = 237496238;</code>
     * @return string
     */
    public function getReplacementMethod()
    {
        return $this->replacement_method;
    }

    /**
     * What action should be used to replace instances. See minimal_action.REPLACE
     *
     * Generated from protobuf field <code>string replacement_method = 237496238;</code>
     * @param string $var
     * @return $this
     */
    public function setReplacementMethod($var)
    {
        GPBUtil::checkString($var, True);
        $this->replacement_method = $var;

        return $this;
    }

    /**
     * The type of update process. You can specify either PROACTIVE so that the instance group manager proactively executes actions in order to bring instances to their target versions or OPPORTUNISTIC so that no action is proactively executed but the update will be performed as part of other actions (for example, resizes or recreateInstances calls).
     *
     * Generated from protobuf field <code>string type = 3575610;</code>
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * The type of update process. You can specify either PROACTIVE so that the instance group manager proactively executes actions in order to bring instances to their target versions or OPPORTUNISTIC so that no action is proactively executed but the update will be performed as part of other actions (for example, resizes or recreateInstances calls).
     *
     * Generated from protobuf field <code>string type = 3575610;</code>
     * @param string $var
     * @return $this
     */
    public function setType($var)
    {
        GPBUtil::checkString($var, True);
        $this->type = $var;

        return $this;
    }

}

