<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/compute/v1/compute.proto

namespace Google\Cloud\Compute\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents an Interconnect Attachment (VLAN) Location resource.
 * You can use this resource to find location details about an Interconnect attachment (VLAN). For more information about interconnect attachments, read  Creating VLAN Attachments.
 *
 * Generated from protobuf message <code>google.cloud.compute.v1.InterconnectLocation</code>
 */
class InterconnectLocation extends \Google\Protobuf\Internal\Message
{
    /**
     * [Output Only] The postal address of the Point of Presence, each line in the address is separated by a newline character.
     *
     * Generated from protobuf field <code>string address = 194485236;</code>
     */
    private $address = '';
    /**
     * [Output Only] Availability zone for this InterconnectLocation. Within a metropolitan area (metro), maintenance will not be simultaneously scheduled in more than one availability zone. Example: "zone1" or "zone2".
     *
     * Generated from protobuf field <code>string availability_zone = 158459920;</code>
     */
    private $availability_zone = '';
    /**
     * [Output Only] Metropolitan area designator that indicates which city an interconnect is located. For example: "Chicago, IL", "Amsterdam, Netherlands".
     *
     * Generated from protobuf field <code>string city = 3053931;</code>
     */
    private $city = '';
    /**
     * [Output Only] Continent for this location, which can take one of the following values:
     * - AFRICA
     * - ASIA_PAC
     * - EUROPE
     * - NORTH_AMERICA
     * - SOUTH_AMERICA
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectLocation.Continent continent = 133442996;</code>
     */
    private $continent = 0;
    /**
     * [Output Only] Creation timestamp in RFC3339 text format.
     *
     * Generated from protobuf field <code>string creation_timestamp = 30525366;</code>
     */
    private $creation_timestamp = '';
    /**
     * [Output Only] An optional description of the resource.
     *
     * Generated from protobuf field <code>string description = 154502140;</code>
     */
    private $description = '';
    /**
     * [Output Only] The name of the provider for this facility (e.g., EQUINIX).
     *
     * Generated from protobuf field <code>string facility_provider = 264867853;</code>
     */
    private $facility_provider = '';
    /**
     * [Output Only] A provider-assigned Identifier for this facility (e.g., Ashburn-DC1).
     *
     * Generated from protobuf field <code>string facility_provider_facility_id = 87269125;</code>
     */
    private $facility_provider_facility_id = '';
    /**
     * [Output Only] The unique identifier for the resource. This identifier is defined by the server.
     *
     * Generated from protobuf field <code>string id = 3355;</code>
     */
    private $id = '';
    /**
     * [Output Only] Type of the resource. Always compute#interconnectLocation for interconnect locations.
     *
     * Generated from protobuf field <code>string kind = 3292052;</code>
     */
    private $kind = '';
    /**
     * [Output Only] Name of the resource.
     *
     * Generated from protobuf field <code>string name = 3373707;</code>
     */
    private $name = '';
    /**
     * [Output Only] The peeringdb identifier for this facility (corresponding with a netfac type in peeringdb).
     *
     * Generated from protobuf field <code>string peeringdb_facility_id = 268131638;</code>
     */
    private $peeringdb_facility_id = '';
    /**
     * [Output Only] A list of InterconnectLocation.RegionInfo objects, that describe parameters pertaining to the relation between this InterconnectLocation and various Google Cloud regions.
     *
     * Generated from protobuf field <code>repeated .google.cloud.compute.v1.InterconnectLocationRegionInfo region_infos = 43758714;</code>
     */
    private $region_infos;
    /**
     * [Output Only] Server-defined URL for the resource.
     *
     * Generated from protobuf field <code>string self_link = 187779341;</code>
     */
    private $self_link = '';
    /**
     * [Output Only] The status of this InterconnectLocation, which can take one of the following values:
     * - CLOSED: The InterconnectLocation is closed and is unavailable for provisioning new Interconnects.
     * - AVAILABLE: The InterconnectLocation is available for provisioning new Interconnects.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectLocation.Status status = 181260274;</code>
     */
    private $status = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $address
     *           [Output Only] The postal address of the Point of Presence, each line in the address is separated by a newline character.
     *     @type string $availability_zone
     *           [Output Only] Availability zone for this InterconnectLocation. Within a metropolitan area (metro), maintenance will not be simultaneously scheduled in more than one availability zone. Example: "zone1" or "zone2".
     *     @type string $city
     *           [Output Only] Metropolitan area designator that indicates which city an interconnect is located. For example: "Chicago, IL", "Amsterdam, Netherlands".
     *     @type int $continent
     *           [Output Only] Continent for this location, which can take one of the following values:
     *           - AFRICA
     *           - ASIA_PAC
     *           - EUROPE
     *           - NORTH_AMERICA
     *           - SOUTH_AMERICA
     *     @type string $creation_timestamp
     *           [Output Only] Creation timestamp in RFC3339 text format.
     *     @type string $description
     *           [Output Only] An optional description of the resource.
     *     @type string $facility_provider
     *           [Output Only] The name of the provider for this facility (e.g., EQUINIX).
     *     @type string $facility_provider_facility_id
     *           [Output Only] A provider-assigned Identifier for this facility (e.g., Ashburn-DC1).
     *     @type string $id
     *           [Output Only] The unique identifier for the resource. This identifier is defined by the server.
     *     @type string $kind
     *           [Output Only] Type of the resource. Always compute#interconnectLocation for interconnect locations.
     *     @type string $name
     *           [Output Only] Name of the resource.
     *     @type string $peeringdb_facility_id
     *           [Output Only] The peeringdb identifier for this facility (corresponding with a netfac type in peeringdb).
     *     @type \Google\Cloud\Compute\V1\InterconnectLocationRegionInfo[]|\Google\Protobuf\Internal\RepeatedField $region_infos
     *           [Output Only] A list of InterconnectLocation.RegionInfo objects, that describe parameters pertaining to the relation between this InterconnectLocation and various Google Cloud regions.
     *     @type string $self_link
     *           [Output Only] Server-defined URL for the resource.
     *     @type int $status
     *           [Output Only] The status of this InterconnectLocation, which can take one of the following values:
     *           - CLOSED: The InterconnectLocation is closed and is unavailable for provisioning new Interconnects.
     *           - AVAILABLE: The InterconnectLocation is available for provisioning new Interconnects.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Compute\V1\Compute::initOnce();
        parent::__construct($data);
    }

    /**
     * [Output Only] The postal address of the Point of Presence, each line in the address is separated by a newline character.
     *
     * Generated from protobuf field <code>string address = 194485236;</code>
     * @return string
     */
    public function getAddress()
    {
        return $this->address;
    }

    /**
     * [Output Only] The postal address of the Point of Presence, each line in the address is separated by a newline character.
     *
     * Generated from protobuf field <code>string address = 194485236;</code>
     * @param string $var
     * @return $this
     */
    public function setAddress($var)
    {
        GPBUtil::checkString($var, True);
        $this->address = $var;

        return $this;
    }

    /**
     * [Output Only] Availability zone for this InterconnectLocation. Within a metropolitan area (metro), maintenance will not be simultaneously scheduled in more than one availability zone. Example: "zone1" or "zone2".
     *
     * Generated from protobuf field <code>string availability_zone = 158459920;</code>
     * @return string
     */
    public function getAvailabilityZone()
    {
        return $this->availability_zone;
    }

    /**
     * [Output Only] Availability zone for this InterconnectLocation. Within a metropolitan area (metro), maintenance will not be simultaneously scheduled in more than one availability zone. Example: "zone1" or "zone2".
     *
     * Generated from protobuf field <code>string availability_zone = 158459920;</code>
     * @param string $var
     * @return $this
     */
    public function setAvailabilityZone($var)
    {
        GPBUtil::checkString($var, True);
        $this->availability_zone = $var;

        return $this;
    }

    /**
     * [Output Only] Metropolitan area designator that indicates which city an interconnect is located. For example: "Chicago, IL", "Amsterdam, Netherlands".
     *
     * Generated from protobuf field <code>string city = 3053931;</code>
     * @return string
     */
    public function getCity()
    {
        return $this->city;
    }

    /**
     * [Output Only] Metropolitan area designator that indicates which city an interconnect is located. For example: "Chicago, IL", "Amsterdam, Netherlands".
     *
     * Generated from protobuf field <code>string city = 3053931;</code>
     * @param string $var
     * @return $this
     */
    public function setCity($var)
    {
        GPBUtil::checkString($var, True);
        $this->city = $var;

        return $this;
    }

    /**
     * [Output Only] Continent for this location, which can take one of the following values:
     * - AFRICA
     * - ASIA_PAC
     * - EUROPE
     * - NORTH_AMERICA
     * - SOUTH_AMERICA
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectLocation.Continent continent = 133442996;</code>
     * @return int
     */
    public function getContinent()
    {
        return $this->continent;
    }

    /**
     * [Output Only] Continent for this location, which can take one of the following values:
     * - AFRICA
     * - ASIA_PAC
     * - EUROPE
     * - NORTH_AMERICA
     * - SOUTH_AMERICA
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectLocation.Continent continent = 133442996;</code>
     * @param int $var
     * @return $this
     */
    public function setContinent($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Compute\V1\InterconnectLocation\Continent::class);
        $this->continent = $var;

        return $this;
    }

    /**
     * [Output Only] Creation timestamp in RFC3339 text format.
     *
     * Generated from protobuf field <code>string creation_timestamp = 30525366;</code>
     * @return string
     */
    public function getCreationTimestamp()
    {
        return $this->creation_timestamp;
    }

    /**
     * [Output Only] Creation timestamp in RFC3339 text format.
     *
     * Generated from protobuf field <code>string creation_timestamp = 30525366;</code>
     * @param string $var
     * @return $this
     */
    public function setCreationTimestamp($var)
    {
        GPBUtil::checkString($var, True);
        $this->creation_timestamp = $var;

        return $this;
    }

    /**
     * [Output Only] An optional description of the resource.
     *
     * Generated from protobuf field <code>string description = 154502140;</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * [Output Only] An optional description of the resource.
     *
     * Generated from protobuf field <code>string description = 154502140;</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * [Output Only] The name of the provider for this facility (e.g., EQUINIX).
     *
     * Generated from protobuf field <code>string facility_provider = 264867853;</code>
     * @return string
     */
    public function getFacilityProvider()
    {
        return $this->facility_provider;
    }

    /**
     * [Output Only] The name of the provider for this facility (e.g., EQUINIX).
     *
     * Generated from protobuf field <code>string facility_provider = 264867853;</code>
     * @param string $var
     * @return $this
     */
    public function setFacilityProvider($var)
    {
        GPBUtil::checkString($var, True);
        $this->facility_provider = $var;

        return $this;
    }

    /**
     * [Output Only] A provider-assigned Identifier for this facility (e.g., Ashburn-DC1).
     *
     * Generated from protobuf field <code>string facility_provider_facility_id = 87269125;</code>
     * @return string
     */
    public function getFacilityProviderFacilityId()
    {
        return $this->facility_provider_facility_id;
    }

    /**
     * [Output Only] A provider-assigned Identifier for this facility (e.g., Ashburn-DC1).
     *
     * Generated from protobuf field <code>string facility_provider_facility_id = 87269125;</code>
     * @param string $var
     * @return $this
     */
    public function setFacilityProviderFacilityId($var)
    {
        GPBUtil::checkString($var, True);
        $this->facility_provider_facility_id = $var;

        return $this;
    }

    /**
     * [Output Only] The unique identifier for the resource. This identifier is defined by the server.
     *
     * Generated from protobuf field <code>string id = 3355;</code>
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * [Output Only] The unique identifier for the resource. This identifier is defined by the server.
     *
     * Generated from protobuf field <code>string id = 3355;</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * [Output Only] Type of the resource. Always compute#interconnectLocation for interconnect locations.
     *
     * Generated from protobuf field <code>string kind = 3292052;</code>
     * @return string
     */
    public function getKind()
    {
        return $this->kind;
    }

    /**
     * [Output Only] Type of the resource. Always compute#interconnectLocation for interconnect locations.
     *
     * Generated from protobuf field <code>string kind = 3292052;</code>
     * @param string $var
     * @return $this
     */
    public function setKind($var)
    {
        GPBUtil::checkString($var, True);
        $this->kind = $var;

        return $this;
    }

    /**
     * [Output Only] Name of the resource.
     *
     * Generated from protobuf field <code>string name = 3373707;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * [Output Only] Name of the resource.
     *
     * Generated from protobuf field <code>string name = 3373707;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * [Output Only] The peeringdb identifier for this facility (corresponding with a netfac type in peeringdb).
     *
     * Generated from protobuf field <code>string peeringdb_facility_id = 268131638;</code>
     * @return string
     */
    public function getPeeringdbFacilityId()
    {
        return $this->peeringdb_facility_id;
    }

    /**
     * [Output Only] The peeringdb identifier for this facility (corresponding with a netfac type in peeringdb).
     *
     * Generated from protobuf field <code>string peeringdb_facility_id = 268131638;</code>
     * @param string $var
     * @return $this
     */
    public function setPeeringdbFacilityId($var)
    {
        GPBUtil::checkString($var, True);
        $this->peeringdb_facility_id = $var;

        return $this;
    }

    /**
     * [Output Only] A list of InterconnectLocation.RegionInfo objects, that describe parameters pertaining to the relation between this InterconnectLocation and various Google Cloud regions.
     *
     * Generated from protobuf field <code>repeated .google.cloud.compute.v1.InterconnectLocationRegionInfo region_infos = 43758714;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getRegionInfos()
    {
        return $this->region_infos;
    }

    /**
     * [Output Only] A list of InterconnectLocation.RegionInfo objects, that describe parameters pertaining to the relation between this InterconnectLocation and various Google Cloud regions.
     *
     * Generated from protobuf field <code>repeated .google.cloud.compute.v1.InterconnectLocationRegionInfo region_infos = 43758714;</code>
     * @param \Google\Cloud\Compute\V1\InterconnectLocationRegionInfo[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setRegionInfos($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Compute\V1\InterconnectLocationRegionInfo::class);
        $this->region_infos = $arr;

        return $this;
    }

    /**
     * [Output Only] Server-defined URL for the resource.
     *
     * Generated from protobuf field <code>string self_link = 187779341;</code>
     * @return string
     */
    public function getSelfLink()
    {
        return $this->self_link;
    }

    /**
     * [Output Only] Server-defined URL for the resource.
     *
     * Generated from protobuf field <code>string self_link = 187779341;</code>
     * @param string $var
     * @return $this
     */
    public function setSelfLink($var)
    {
        GPBUtil::checkString($var, True);
        $this->self_link = $var;

        return $this;
    }

    /**
     * [Output Only] The status of this InterconnectLocation, which can take one of the following values:
     * - CLOSED: The InterconnectLocation is closed and is unavailable for provisioning new Interconnects.
     * - AVAILABLE: The InterconnectLocation is available for provisioning new Interconnects.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectLocation.Status status = 181260274;</code>
     * @return int
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * [Output Only] The status of this InterconnectLocation, which can take one of the following values:
     * - CLOSED: The InterconnectLocation is closed and is unavailable for provisioning new Interconnects.
     * - AVAILABLE: The InterconnectLocation is available for provisioning new Interconnects.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectLocation.Status status = 181260274;</code>
     * @param int $var
     * @return $this
     */
    public function setStatus($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Compute\V1\InterconnectLocation\Status::class);
        $this->status = $var;

        return $this;
    }

}

