<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/compute/v1/compute.proto

namespace Google\Cloud\Compute\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Description of a planned outage on this Interconnect.
 *
 * Generated from protobuf message <code>google.cloud.compute.v1.InterconnectOutageNotification</code>
 */
class InterconnectOutageNotification extends \Google\Protobuf\Internal\Message
{
    /**
     * If issue_type is IT_PARTIAL_OUTAGE, a list of the Google-side circuit IDs that will be affected.
     *
     * Generated from protobuf field <code>repeated string affected_circuits = 177717013;</code>
     */
    private $affected_circuits;
    /**
     * A description about the purpose of the outage.
     *
     * Generated from protobuf field <code>string description = 154502140;</code>
     */
    private $description = '';
    /**
     * Scheduled end time for the outage (milliseconds since Unix epoch).
     *
     * Generated from protobuf field <code>string end_time = 114938801;</code>
     */
    private $end_time = '';
    /**
     * Form this outage is expected to take, which can take one of the following values:
     * - OUTAGE: The Interconnect may be completely out of service for some or all of the specified window.
     * - PARTIAL_OUTAGE: Some circuits comprising the Interconnect as a whole should remain up, but with reduced bandwidth. Note that the versions of this enum prefixed with "IT_" have been deprecated in favor of the unprefixed values.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectOutageNotification.IssueType issue_type = 101203680;</code>
     */
    private $issue_type = 0;
    /**
     * Unique identifier for this outage notification.
     *
     * Generated from protobuf field <code>string name = 3373707;</code>
     */
    private $name = '';
    /**
     * The party that generated this notification, which can take the following value:
     * - GOOGLE: this notification as generated by Google. Note that the value of NSRC_GOOGLE has been deprecated in favor of GOOGLE.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectOutageNotification.Source source = 177235995;</code>
     */
    private $source = 0;
    /**
     * Scheduled start time for the outage (milliseconds since Unix epoch).
     *
     * Generated from protobuf field <code>string start_time = 37467274;</code>
     */
    private $start_time = '';
    /**
     * State of this notification, which can take one of the following values:
     * - ACTIVE: This outage notification is active. The event could be in the past, present, or future. See start_time and end_time for scheduling.
     * - CANCELLED: The outage associated with this notification was cancelled before the outage was due to start. Note that the versions of this enum prefixed with "NS_" have been deprecated in favor of the unprefixed values.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectOutageNotification.State state = 109757585;</code>
     */
    private $state = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string[]|\Google\Protobuf\Internal\RepeatedField $affected_circuits
     *           If issue_type is IT_PARTIAL_OUTAGE, a list of the Google-side circuit IDs that will be affected.
     *     @type string $description
     *           A description about the purpose of the outage.
     *     @type string $end_time
     *           Scheduled end time for the outage (milliseconds since Unix epoch).
     *     @type int $issue_type
     *           Form this outage is expected to take, which can take one of the following values:
     *           - OUTAGE: The Interconnect may be completely out of service for some or all of the specified window.
     *           - PARTIAL_OUTAGE: Some circuits comprising the Interconnect as a whole should remain up, but with reduced bandwidth. Note that the versions of this enum prefixed with "IT_" have been deprecated in favor of the unprefixed values.
     *     @type string $name
     *           Unique identifier for this outage notification.
     *     @type int $source
     *           The party that generated this notification, which can take the following value:
     *           - GOOGLE: this notification as generated by Google. Note that the value of NSRC_GOOGLE has been deprecated in favor of GOOGLE.
     *     @type string $start_time
     *           Scheduled start time for the outage (milliseconds since Unix epoch).
     *     @type int $state
     *           State of this notification, which can take one of the following values:
     *           - ACTIVE: This outage notification is active. The event could be in the past, present, or future. See start_time and end_time for scheduling.
     *           - CANCELLED: The outage associated with this notification was cancelled before the outage was due to start. Note that the versions of this enum prefixed with "NS_" have been deprecated in favor of the unprefixed values.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Compute\V1\Compute::initOnce();
        parent::__construct($data);
    }

    /**
     * If issue_type is IT_PARTIAL_OUTAGE, a list of the Google-side circuit IDs that will be affected.
     *
     * Generated from protobuf field <code>repeated string affected_circuits = 177717013;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getAffectedCircuits()
    {
        return $this->affected_circuits;
    }

    /**
     * If issue_type is IT_PARTIAL_OUTAGE, a list of the Google-side circuit IDs that will be affected.
     *
     * Generated from protobuf field <code>repeated string affected_circuits = 177717013;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setAffectedCircuits($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->affected_circuits = $arr;

        return $this;
    }

    /**
     * A description about the purpose of the outage.
     *
     * Generated from protobuf field <code>string description = 154502140;</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * A description about the purpose of the outage.
     *
     * Generated from protobuf field <code>string description = 154502140;</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * Scheduled end time for the outage (milliseconds since Unix epoch).
     *
     * Generated from protobuf field <code>string end_time = 114938801;</code>
     * @return string
     */
    public function getEndTime()
    {
        return $this->end_time;
    }

    /**
     * Scheduled end time for the outage (milliseconds since Unix epoch).
     *
     * Generated from protobuf field <code>string end_time = 114938801;</code>
     * @param string $var
     * @return $this
     */
    public function setEndTime($var)
    {
        GPBUtil::checkString($var, True);
        $this->end_time = $var;

        return $this;
    }

    /**
     * Form this outage is expected to take, which can take one of the following values:
     * - OUTAGE: The Interconnect may be completely out of service for some or all of the specified window.
     * - PARTIAL_OUTAGE: Some circuits comprising the Interconnect as a whole should remain up, but with reduced bandwidth. Note that the versions of this enum prefixed with "IT_" have been deprecated in favor of the unprefixed values.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectOutageNotification.IssueType issue_type = 101203680;</code>
     * @return int
     */
    public function getIssueType()
    {
        return $this->issue_type;
    }

    /**
     * Form this outage is expected to take, which can take one of the following values:
     * - OUTAGE: The Interconnect may be completely out of service for some or all of the specified window.
     * - PARTIAL_OUTAGE: Some circuits comprising the Interconnect as a whole should remain up, but with reduced bandwidth. Note that the versions of this enum prefixed with "IT_" have been deprecated in favor of the unprefixed values.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectOutageNotification.IssueType issue_type = 101203680;</code>
     * @param int $var
     * @return $this
     */
    public function setIssueType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Compute\V1\InterconnectOutageNotification\IssueType::class);
        $this->issue_type = $var;

        return $this;
    }

    /**
     * Unique identifier for this outage notification.
     *
     * Generated from protobuf field <code>string name = 3373707;</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Unique identifier for this outage notification.
     *
     * Generated from protobuf field <code>string name = 3373707;</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * The party that generated this notification, which can take the following value:
     * - GOOGLE: this notification as generated by Google. Note that the value of NSRC_GOOGLE has been deprecated in favor of GOOGLE.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectOutageNotification.Source source = 177235995;</code>
     * @return int
     */
    public function getSource()
    {
        return $this->source;
    }

    /**
     * The party that generated this notification, which can take the following value:
     * - GOOGLE: this notification as generated by Google. Note that the value of NSRC_GOOGLE has been deprecated in favor of GOOGLE.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectOutageNotification.Source source = 177235995;</code>
     * @param int $var
     * @return $this
     */
    public function setSource($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Compute\V1\InterconnectOutageNotification\Source::class);
        $this->source = $var;

        return $this;
    }

    /**
     * Scheduled start time for the outage (milliseconds since Unix epoch).
     *
     * Generated from protobuf field <code>string start_time = 37467274;</code>
     * @return string
     */
    public function getStartTime()
    {
        return $this->start_time;
    }

    /**
     * Scheduled start time for the outage (milliseconds since Unix epoch).
     *
     * Generated from protobuf field <code>string start_time = 37467274;</code>
     * @param string $var
     * @return $this
     */
    public function setStartTime($var)
    {
        GPBUtil::checkString($var, True);
        $this->start_time = $var;

        return $this;
    }

    /**
     * State of this notification, which can take one of the following values:
     * - ACTIVE: This outage notification is active. The event could be in the past, present, or future. See start_time and end_time for scheduling.
     * - CANCELLED: The outage associated with this notification was cancelled before the outage was due to start. Note that the versions of this enum prefixed with "NS_" have been deprecated in favor of the unprefixed values.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectOutageNotification.State state = 109757585;</code>
     * @return int
     */
    public function getState()
    {
        return $this->state;
    }

    /**
     * State of this notification, which can take one of the following values:
     * - ACTIVE: This outage notification is active. The event could be in the past, present, or future. See start_time and end_time for scheduling.
     * - CANCELLED: The outage associated with this notification was cancelled before the outage was due to start. Note that the versions of this enum prefixed with "NS_" have been deprecated in favor of the unprefixed values.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.InterconnectOutageNotification.State state = 109757585;</code>
     * @param int $var
     * @return $this
     */
    public function setState($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Compute\V1\InterconnectOutageNotification\State::class);
        $this->state = $var;

        return $this;
    }

}

