<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/compute/v1/compute.proto

namespace Google\Cloud\Compute\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Represents a rule that describes one or more match conditions along with the action to be taken when traffic matches this condition (allow or deny).
 *
 * Generated from protobuf message <code>google.cloud.compute.v1.SecurityPolicyRule</code>
 */
class SecurityPolicyRule extends \Google\Protobuf\Internal\Message
{
    /**
     * The Action to preform when the client connection triggers the rule. Can currently be either "allow" or "deny()" where valid values for status are 403, 404, and 502.
     *
     * Generated from protobuf field <code>string action = 187661878;</code>
     */
    private $action = '';
    /**
     * An optional description of this resource. Provide this property when you create the resource.
     *
     * Generated from protobuf field <code>string description = 154502140;</code>
     */
    private $description = '';
    /**
     * [Output only] Type of the resource. Always compute#securityPolicyRule for security policy rules
     *
     * Generated from protobuf field <code>string kind = 3292052;</code>
     */
    private $kind = '';
    /**
     * A match condition that incoming traffic is evaluated against. If it evaluates to true, the corresponding 'action' is enforced.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.SecurityPolicyRuleMatcher match = 103668165;</code>
     */
    private $match = null;
    /**
     * If set to true, the specified action is not enforced.
     *
     * Generated from protobuf field <code>bool preview = 218686408;</code>
     */
    private $preview = false;
    /**
     * An integer indicating the priority of a rule in the list. The priority must be a positive value between 0 and 2147483647. Rules are evaluated from highest to lowest priority where 0 is the highest priority and 2147483647 is the lowest priority.
     *
     * Generated from protobuf field <code>int32 priority = 176716196;</code>
     */
    private $priority = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $action
     *           The Action to preform when the client connection triggers the rule. Can currently be either "allow" or "deny()" where valid values for status are 403, 404, and 502.
     *     @type string $description
     *           An optional description of this resource. Provide this property when you create the resource.
     *     @type string $kind
     *           [Output only] Type of the resource. Always compute#securityPolicyRule for security policy rules
     *     @type \Google\Cloud\Compute\V1\SecurityPolicyRuleMatcher $match
     *           A match condition that incoming traffic is evaluated against. If it evaluates to true, the corresponding 'action' is enforced.
     *     @type bool $preview
     *           If set to true, the specified action is not enforced.
     *     @type int $priority
     *           An integer indicating the priority of a rule in the list. The priority must be a positive value between 0 and 2147483647. Rules are evaluated from highest to lowest priority where 0 is the highest priority and 2147483647 is the lowest priority.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Compute\V1\Compute::initOnce();
        parent::__construct($data);
    }

    /**
     * The Action to preform when the client connection triggers the rule. Can currently be either "allow" or "deny()" where valid values for status are 403, 404, and 502.
     *
     * Generated from protobuf field <code>string action = 187661878;</code>
     * @return string
     */
    public function getAction()
    {
        return $this->action;
    }

    /**
     * The Action to preform when the client connection triggers the rule. Can currently be either "allow" or "deny()" where valid values for status are 403, 404, and 502.
     *
     * Generated from protobuf field <code>string action = 187661878;</code>
     * @param string $var
     * @return $this
     */
    public function setAction($var)
    {
        GPBUtil::checkString($var, True);
        $this->action = $var;

        return $this;
    }

    /**
     * An optional description of this resource. Provide this property when you create the resource.
     *
     * Generated from protobuf field <code>string description = 154502140;</code>
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * An optional description of this resource. Provide this property when you create the resource.
     *
     * Generated from protobuf field <code>string description = 154502140;</code>
     * @param string $var
     * @return $this
     */
    public function setDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->description = $var;

        return $this;
    }

    /**
     * [Output only] Type of the resource. Always compute#securityPolicyRule for security policy rules
     *
     * Generated from protobuf field <code>string kind = 3292052;</code>
     * @return string
     */
    public function getKind()
    {
        return $this->kind;
    }

    /**
     * [Output only] Type of the resource. Always compute#securityPolicyRule for security policy rules
     *
     * Generated from protobuf field <code>string kind = 3292052;</code>
     * @param string $var
     * @return $this
     */
    public function setKind($var)
    {
        GPBUtil::checkString($var, True);
        $this->kind = $var;

        return $this;
    }

    /**
     * A match condition that incoming traffic is evaluated against. If it evaluates to true, the corresponding 'action' is enforced.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.SecurityPolicyRuleMatcher match = 103668165;</code>
     * @return \Google\Cloud\Compute\V1\SecurityPolicyRuleMatcher
     */
    public function getMatch()
    {
        return isset($this->match) ? $this->match : null;
    }

    public function hasMatch()
    {
        return isset($this->match);
    }

    public function clearMatch()
    {
        unset($this->match);
    }

    /**
     * A match condition that incoming traffic is evaluated against. If it evaluates to true, the corresponding 'action' is enforced.
     *
     * Generated from protobuf field <code>.google.cloud.compute.v1.SecurityPolicyRuleMatcher match = 103668165;</code>
     * @param \Google\Cloud\Compute\V1\SecurityPolicyRuleMatcher $var
     * @return $this
     */
    public function setMatch($var)
    {
        GPBUtil::checkMessage($var, \Google\Cloud\Compute\V1\SecurityPolicyRuleMatcher::class);
        $this->match = $var;

        return $this;
    }

    /**
     * If set to true, the specified action is not enforced.
     *
     * Generated from protobuf field <code>bool preview = 218686408;</code>
     * @return bool
     */
    public function getPreview()
    {
        return $this->preview;
    }

    /**
     * If set to true, the specified action is not enforced.
     *
     * Generated from protobuf field <code>bool preview = 218686408;</code>
     * @param bool $var
     * @return $this
     */
    public function setPreview($var)
    {
        GPBUtil::checkBool($var);
        $this->preview = $var;

        return $this;
    }

    /**
     * An integer indicating the priority of a rule in the list. The priority must be a positive value between 0 and 2147483647. Rules are evaluated from highest to lowest priority where 0 is the highest priority and 2147483647 is the lowest priority.
     *
     * Generated from protobuf field <code>int32 priority = 176716196;</code>
     * @return int
     */
    public function getPriority()
    {
        return $this->priority;
    }

    /**
     * An integer indicating the priority of a rule in the list. The priority must be a positive value between 0 and 2147483647. Rules are evaluated from highest to lowest priority where 0 is the highest priority and 2147483647 is the lowest priority.
     *
     * Generated from protobuf field <code>int32 priority = 176716196;</code>
     * @param int $var
     * @return $this
     */
    public function setPriority($var)
    {
        GPBUtil::checkInt32($var);
        $this->priority = $var;

        return $this;
    }

}

