<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/datacatalog/v1/datacatalog.proto

namespace Google\Cloud\DataCatalog\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [ListEntries][google.cloud.datacatalog.v1.DataCatalog.ListEntries].
 *
 * Generated from protobuf message <code>google.cloud.datacatalog.v1.ListEntriesRequest</code>
 */
class ListEntriesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The name of the entry group that contains the entries, which can
     * be provided in URL format. Example:
     * * projects/{project_id}/locations/{location}/entryGroups/{entry_group_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * The maximum number of items to return. Default is 10. Max limit is 1000.
     * Throws an invalid argument for `page_size > 1000`.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     */
    private $page_size = 0;
    /**
     * Token that specifies which page is requested. If empty, the first page is
     * returned.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     */
    private $page_token = '';
    /**
     * The fields to return for each Entry. If not set or empty, all
     * fields are returned.
     * For example, setting read_mask to contain only one path "name" will cause
     * ListEntries to return a list of Entries with only "name" field.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask read_mask = 4;</code>
     */
    private $read_mask = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The name of the entry group that contains the entries, which can
     *           be provided in URL format. Example:
     *           * projects/{project_id}/locations/{location}/entryGroups/{entry_group_id}
     *     @type int $page_size
     *           The maximum number of items to return. Default is 10. Max limit is 1000.
     *           Throws an invalid argument for `page_size > 1000`.
     *     @type string $page_token
     *           Token that specifies which page is requested. If empty, the first page is
     *           returned.
     *     @type \Google\Protobuf\FieldMask $read_mask
     *           The fields to return for each Entry. If not set or empty, all
     *           fields are returned.
     *           For example, setting read_mask to contain only one path "name" will cause
     *           ListEntries to return a list of Entries with only "name" field.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Datacatalog\V1\Datacatalog::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The name of the entry group that contains the entries, which can
     * be provided in URL format. Example:
     * * projects/{project_id}/locations/{location}/entryGroups/{entry_group_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The name of the entry group that contains the entries, which can
     * be provided in URL format. Example:
     * * projects/{project_id}/locations/{location}/entryGroups/{entry_group_id}
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The maximum number of items to return. Default is 10. Max limit is 1000.
     * Throws an invalid argument for `page_size > 1000`.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * The maximum number of items to return. Default is 10. Max limit is 1000.
     * Throws an invalid argument for `page_size > 1000`.
     *
     * Generated from protobuf field <code>int32 page_size = 2;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * Token that specifies which page is requested. If empty, the first page is
     * returned.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * Token that specifies which page is requested. If empty, the first page is
     * returned.
     *
     * Generated from protobuf field <code>string page_token = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

    /**
     * The fields to return for each Entry. If not set or empty, all
     * fields are returned.
     * For example, setting read_mask to contain only one path "name" will cause
     * ListEntries to return a list of Entries with only "name" field.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask read_mask = 4;</code>
     * @return \Google\Protobuf\FieldMask
     */
    public function getReadMask()
    {
        return isset($this->read_mask) ? $this->read_mask : null;
    }

    public function hasReadMask()
    {
        return isset($this->read_mask);
    }

    public function clearReadMask()
    {
        unset($this->read_mask);
    }

    /**
     * The fields to return for each Entry. If not set or empty, all
     * fields are returned.
     * For example, setting read_mask to contain only one path "name" will cause
     * ListEntries to return a list of Entries with only "name" field.
     *
     * Generated from protobuf field <code>.google.protobuf.FieldMask read_mask = 4;</code>
     * @param \Google\Protobuf\FieldMask $var
     * @return $this
     */
    public function setReadMask($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\FieldMask::class);
        $this->read_mask = $var;

        return $this;
    }

}

