<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/datacatalog/v1/datacatalog.proto

namespace Google\Cloud\DataCatalog\V1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request message for
 * [LookupEntry][google.cloud.datacatalog.v1.DataCatalog.LookupEntry].
 *
 * Generated from protobuf message <code>google.cloud.datacatalog.v1.LookupEntryRequest</code>
 */
class LookupEntryRequest extends \Google\Protobuf\Internal\Message
{
    protected $target_name;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $linked_resource
     *           The full name of the Google Cloud Platform resource the Data Catalog
     *           entry represents. See:
     *           https://cloud.google.com/apis/design/resource_names#full_resource_name.
     *           Full names are case-sensitive.
     *           Examples:
     *            * //bigquery.googleapis.com/projects/projectId/datasets/datasetId/tables/tableId
     *            * //pubsub.googleapis.com/projects/projectId/topics/topicId
     *     @type string $sql_resource
     *           The SQL name of the entry. SQL names are case-sensitive.
     *           Examples:
     *             * `pubsub.project_id.topic_id`
     *             * ``pubsub.project_id.`topic.id.with.dots` ``
     *             * `bigquery.table.project_id.dataset_id.table_id`
     *             * `bigquery.dataset.project_id.dataset_id`
     *             * `datacatalog.entry.project_id.location_id.entry_group_id.entry_id`
     *           `*_id`s shoud satisfy the standard SQL rules for identifiers.
     *           https://cloud.google.com/bigquery/docs/reference/standard-sql/lexical.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Datacatalog\V1\Datacatalog::initOnce();
        parent::__construct($data);
    }

    /**
     * The full name of the Google Cloud Platform resource the Data Catalog
     * entry represents. See:
     * https://cloud.google.com/apis/design/resource_names#full_resource_name.
     * Full names are case-sensitive.
     * Examples:
     *  * //bigquery.googleapis.com/projects/projectId/datasets/datasetId/tables/tableId
     *  * //pubsub.googleapis.com/projects/projectId/topics/topicId
     *
     * Generated from protobuf field <code>string linked_resource = 1;</code>
     * @return string
     */
    public function getLinkedResource()
    {
        return $this->readOneof(1);
    }

    public function hasLinkedResource()
    {
        return $this->hasOneof(1);
    }

    /**
     * The full name of the Google Cloud Platform resource the Data Catalog
     * entry represents. See:
     * https://cloud.google.com/apis/design/resource_names#full_resource_name.
     * Full names are case-sensitive.
     * Examples:
     *  * //bigquery.googleapis.com/projects/projectId/datasets/datasetId/tables/tableId
     *  * //pubsub.googleapis.com/projects/projectId/topics/topicId
     *
     * Generated from protobuf field <code>string linked_resource = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setLinkedResource($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(1, $var);

        return $this;
    }

    /**
     * The SQL name of the entry. SQL names are case-sensitive.
     * Examples:
     *   * `pubsub.project_id.topic_id`
     *   * ``pubsub.project_id.`topic.id.with.dots` ``
     *   * `bigquery.table.project_id.dataset_id.table_id`
     *   * `bigquery.dataset.project_id.dataset_id`
     *   * `datacatalog.entry.project_id.location_id.entry_group_id.entry_id`
     * `*_id`s shoud satisfy the standard SQL rules for identifiers.
     * https://cloud.google.com/bigquery/docs/reference/standard-sql/lexical.
     *
     * Generated from protobuf field <code>string sql_resource = 3;</code>
     * @return string
     */
    public function getSqlResource()
    {
        return $this->readOneof(3);
    }

    public function hasSqlResource()
    {
        return $this->hasOneof(3);
    }

    /**
     * The SQL name of the entry. SQL names are case-sensitive.
     * Examples:
     *   * `pubsub.project_id.topic_id`
     *   * ``pubsub.project_id.`topic.id.with.dots` ``
     *   * `bigquery.table.project_id.dataset_id.table_id`
     *   * `bigquery.dataset.project_id.dataset_id`
     *   * `datacatalog.entry.project_id.location_id.entry_group_id.entry_id`
     * `*_id`s shoud satisfy the standard SQL rules for identifiers.
     * https://cloud.google.com/bigquery/docs/reference/standard-sql/lexical.
     *
     * Generated from protobuf field <code>string sql_resource = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setSqlResource($var)
    {
        GPBUtil::checkString($var, True);
        $this->writeOneof(3, $var);

        return $this;
    }

    /**
     * @return string
     */
    public function getTargetName()
    {
        return $this->whichOneof("target_name");
    }

}

