<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/monitoring/v3/service_service.proto

namespace Google\Cloud\Monitoring\V3;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * The `ListServices` request.
 *
 * Generated from protobuf message <code>google.monitoring.v3.ListServicesRequest</code>
 */
class ListServicesRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. Resource name of the parent containing the listed services, either a
     * project or a Monitoring Workspace. The formats are:
     *     projects/[PROJECT_ID_OR_NUMBER]
     *     workspaces/[HOST_PROJECT_ID_OR_NUMBER]
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * A filter specifying what `Service`s to return. The filter currently
     * supports the following fields:
     *     - `identifier_case`
     *     - `app_engine.module_id`
     *     - `cloud_endpoints.service`
     *     - `cluster_istio.location`
     *     - `cluster_istio.cluster_name`
     *     - `cluster_istio.service_namespace`
     *     - `cluster_istio.service_name`
     * `identifier_case` refers to which option in the identifier oneof is
     * populated. For example, the filter `identifier_case = "CUSTOM"` would match
     * all services with a value for the `custom` field. Valid options are
     * "CUSTOM", "APP_ENGINE", "CLOUD_ENDPOINTS", and "CLUSTER_ISTIO".
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     */
    private $filter = '';
    /**
     * A non-negative number that is the maximum number of results to return.
     * When 0, use default page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     */
    private $page_size = 0;
    /**
     * If this field is not empty then it must contain the `nextPageToken` value
     * returned by a previous call to this method.  Using this field causes the
     * method to return additional results from the previous method call.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     */
    private $page_token = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. Resource name of the parent containing the listed services, either a
     *           project or a Monitoring Workspace. The formats are:
     *               projects/[PROJECT_ID_OR_NUMBER]
     *               workspaces/[HOST_PROJECT_ID_OR_NUMBER]
     *     @type string $filter
     *           A filter specifying what `Service`s to return. The filter currently
     *           supports the following fields:
     *               - `identifier_case`
     *               - `app_engine.module_id`
     *               - `cloud_endpoints.service`
     *               - `cluster_istio.location`
     *               - `cluster_istio.cluster_name`
     *               - `cluster_istio.service_namespace`
     *               - `cluster_istio.service_name`
     *           `identifier_case` refers to which option in the identifier oneof is
     *           populated. For example, the filter `identifier_case = "CUSTOM"` would match
     *           all services with a value for the `custom` field. Valid options are
     *           "CUSTOM", "APP_ENGINE", "CLOUD_ENDPOINTS", and "CLUSTER_ISTIO".
     *     @type int $page_size
     *           A non-negative number that is the maximum number of results to return.
     *           When 0, use default page size.
     *     @type string $page_token
     *           If this field is not empty then it must contain the `nextPageToken` value
     *           returned by a previous call to this method.  Using this field causes the
     *           method to return additional results from the previous method call.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Monitoring\V3\ServiceService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. Resource name of the parent containing the listed services, either a
     * project or a Monitoring Workspace. The formats are:
     *     projects/[PROJECT_ID_OR_NUMBER]
     *     workspaces/[HOST_PROJECT_ID_OR_NUMBER]
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. Resource name of the parent containing the listed services, either a
     * project or a Monitoring Workspace. The formats are:
     *     projects/[PROJECT_ID_OR_NUMBER]
     *     workspaces/[HOST_PROJECT_ID_OR_NUMBER]
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * A filter specifying what `Service`s to return. The filter currently
     * supports the following fields:
     *     - `identifier_case`
     *     - `app_engine.module_id`
     *     - `cloud_endpoints.service`
     *     - `cluster_istio.location`
     *     - `cluster_istio.cluster_name`
     *     - `cluster_istio.service_namespace`
     *     - `cluster_istio.service_name`
     * `identifier_case` refers to which option in the identifier oneof is
     * populated. For example, the filter `identifier_case = "CUSTOM"` would match
     * all services with a value for the `custom` field. Valid options are
     * "CUSTOM", "APP_ENGINE", "CLOUD_ENDPOINTS", and "CLUSTER_ISTIO".
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     * @return string
     */
    public function getFilter()
    {
        return $this->filter;
    }

    /**
     * A filter specifying what `Service`s to return. The filter currently
     * supports the following fields:
     *     - `identifier_case`
     *     - `app_engine.module_id`
     *     - `cloud_endpoints.service`
     *     - `cluster_istio.location`
     *     - `cluster_istio.cluster_name`
     *     - `cluster_istio.service_namespace`
     *     - `cluster_istio.service_name`
     * `identifier_case` refers to which option in the identifier oneof is
     * populated. For example, the filter `identifier_case = "CUSTOM"` would match
     * all services with a value for the `custom` field. Valid options are
     * "CUSTOM", "APP_ENGINE", "CLOUD_ENDPOINTS", and "CLUSTER_ISTIO".
     *
     * Generated from protobuf field <code>string filter = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setFilter($var)
    {
        GPBUtil::checkString($var, True);
        $this->filter = $var;

        return $this;
    }

    /**
     * A non-negative number that is the maximum number of results to return.
     * When 0, use default page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @return int
     */
    public function getPageSize()
    {
        return $this->page_size;
    }

    /**
     * A non-negative number that is the maximum number of results to return.
     * When 0, use default page size.
     *
     * Generated from protobuf field <code>int32 page_size = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setPageSize($var)
    {
        GPBUtil::checkInt32($var);
        $this->page_size = $var;

        return $this;
    }

    /**
     * If this field is not empty then it must contain the `nextPageToken` value
     * returned by a previous call to this method.  Using this field causes the
     * method to return additional results from the previous method call.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @return string
     */
    public function getPageToken()
    {
        return $this->page_token;
    }

    /**
     * If this field is not empty then it must contain the `nextPageToken` value
     * returned by a previous call to this method.  Using this field causes the
     * method to return additional results from the previous method call.
     *
     * Generated from protobuf field <code>string page_token = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setPageToken($var)
    {
        GPBUtil::checkString($var, True);
        $this->page_token = $var;

        return $this;
    }

}

