<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/security/privateca/v1beta1/resources.proto

namespace Google\Cloud\Security\PrivateCA\V1beta1\CertificateAuthority;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Options that affect all certificates issued by a [CertificateAuthority][google.cloud.security.privateca.v1beta1.CertificateAuthority].
 *
 * Generated from protobuf message <code>google.cloud.security.privateca.v1beta1.CertificateAuthority.IssuingOptions</code>
 */
class IssuingOptions extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. When true, includes a URL to the issuing CA certificate in the
     * "authority information access" X.509 extension.
     *
     * Generated from protobuf field <code>bool include_ca_cert_url = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $include_ca_cert_url = false;
    /**
     * Required. When true, includes a URL to the CRL corresponding to certificates
     * issued from a [CertificateAuthority][google.cloud.security.privateca.v1beta1.CertificateAuthority].
     * CRLs will expire 7 days from their creation. However, we will rebuild
     * daily. CRLs are also rebuilt shortly after a certificate is revoked.
     *
     * Generated from protobuf field <code>bool include_crl_access_url = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    private $include_crl_access_url = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type bool $include_ca_cert_url
     *           Required. When true, includes a URL to the issuing CA certificate in the
     *           "authority information access" X.509 extension.
     *     @type bool $include_crl_access_url
     *           Required. When true, includes a URL to the CRL corresponding to certificates
     *           issued from a [CertificateAuthority][google.cloud.security.privateca.v1beta1.CertificateAuthority].
     *           CRLs will expire 7 days from their creation. However, we will rebuild
     *           daily. CRLs are also rebuilt shortly after a certificate is revoked.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Security\Privateca\V1Beta1\Resources::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. When true, includes a URL to the issuing CA certificate in the
     * "authority information access" X.509 extension.
     *
     * Generated from protobuf field <code>bool include_ca_cert_url = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return bool
     */
    public function getIncludeCaCertUrl()
    {
        return $this->include_ca_cert_url;
    }

    /**
     * Required. When true, includes a URL to the issuing CA certificate in the
     * "authority information access" X.509 extension.
     *
     * Generated from protobuf field <code>bool include_ca_cert_url = 1 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param bool $var
     * @return $this
     */
    public function setIncludeCaCertUrl($var)
    {
        GPBUtil::checkBool($var);
        $this->include_ca_cert_url = $var;

        return $this;
    }

    /**
     * Required. When true, includes a URL to the CRL corresponding to certificates
     * issued from a [CertificateAuthority][google.cloud.security.privateca.v1beta1.CertificateAuthority].
     * CRLs will expire 7 days from their creation. However, we will rebuild
     * daily. CRLs are also rebuilt shortly after a certificate is revoked.
     *
     * Generated from protobuf field <code>bool include_crl_access_url = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return bool
     */
    public function getIncludeCrlAccessUrl()
    {
        return $this->include_crl_access_url;
    }

    /**
     * Required. When true, includes a URL to the CRL corresponding to certificates
     * issued from a [CertificateAuthority][google.cloud.security.privateca.v1beta1.CertificateAuthority].
     * CRLs will expire 7 days from their creation. However, we will rebuild
     * daily. CRLs are also rebuilt shortly after a certificate is revoked.
     *
     * Generated from protobuf field <code>bool include_crl_access_url = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param bool $var
     * @return $this
     */
    public function setIncludeCrlAccessUrl($var)
    {
        GPBUtil::checkBool($var);
        $this->include_crl_access_url = $var;

        return $this;
    }

}

// Adding a class alias for backwards compatibility with the previous class name.
class_alias(IssuingOptions::class, \Google\Cloud\Security\PrivateCA\V1beta1\CertificateAuthority_IssuingOptions::class);

