<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/servicedirectory/v1beta1/service.proto

namespace Google\Cloud\ServiceDirectory\V1beta1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An individual service. A service contains a name and optional metadata.
 * A service must exist before
 * [endpoints][google.cloud.servicedirectory.v1beta1.Endpoint] can be
 * added to it.
 *
 * Generated from protobuf message <code>google.cloud.servicedirectory.v1beta1.Service</code>
 */
class Service extends \Google\Protobuf\Internal\Message
{
    /**
     * Immutable. The resource name for the service in the format
     * 'projects/&#42;&#47;locations/&#42;&#47;namespaces/&#42;&#47;services/&#42;'.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     */
    private $name = '';
    /**
     * Optional. Metadata for the service. This data can be consumed by service
     * clients.  The entire metadata dictionary may contain up to 2000 characters,
     * spread across all key-value pairs. Metadata that goes beyond any these
     * limits will be rejected.
     *
     * Generated from protobuf field <code>map<string, string> metadata = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     */
    private $metadata;
    /**
     * Output only. Endpoints associated with this service. Returned on LookupService.Resolve.
     * Control plane clients should use RegistrationService.ListEndpoints.
     *
     * Generated from protobuf field <code>repeated .google.cloud.servicedirectory.v1beta1.Endpoint endpoints = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    private $endpoints;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $name
     *           Immutable. The resource name for the service in the format
     *           'projects/&#42;&#47;locations/&#42;&#47;namespaces/&#42;&#47;services/&#42;'.
     *     @type array|\Google\Protobuf\Internal\MapField $metadata
     *           Optional. Metadata for the service. This data can be consumed by service
     *           clients.  The entire metadata dictionary may contain up to 2000 characters,
     *           spread across all key-value pairs. Metadata that goes beyond any these
     *           limits will be rejected.
     *     @type \Google\Cloud\ServiceDirectory\V1beta1\Endpoint[]|\Google\Protobuf\Internal\RepeatedField $endpoints
     *           Output only. Endpoints associated with this service. Returned on LookupService.Resolve.
     *           Control plane clients should use RegistrationService.ListEndpoints.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Servicedirectory\V1Beta1\Service::initOnce();
        parent::__construct($data);
    }

    /**
     * Immutable. The resource name for the service in the format
     * 'projects/&#42;&#47;locations/&#42;&#47;namespaces/&#42;&#47;services/&#42;'.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Immutable. The resource name for the service in the format
     * 'projects/&#42;&#47;locations/&#42;&#47;namespaces/&#42;&#47;services/&#42;'.
     *
     * Generated from protobuf field <code>string name = 1 [(.google.api.field_behavior) = IMMUTABLE];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Optional. Metadata for the service. This data can be consumed by service
     * clients.  The entire metadata dictionary may contain up to 2000 characters,
     * spread across all key-value pairs. Metadata that goes beyond any these
     * limits will be rejected.
     *
     * Generated from protobuf field <code>map<string, string> metadata = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @return \Google\Protobuf\Internal\MapField
     */
    public function getMetadata()
    {
        return $this->metadata;
    }

    /**
     * Optional. Metadata for the service. This data can be consumed by service
     * clients.  The entire metadata dictionary may contain up to 2000 characters,
     * spread across all key-value pairs. Metadata that goes beyond any these
     * limits will be rejected.
     *
     * Generated from protobuf field <code>map<string, string> metadata = 2 [(.google.api.field_behavior) = OPTIONAL];</code>
     * @param array|\Google\Protobuf\Internal\MapField $var
     * @return $this
     */
    public function setMetadata($var)
    {
        $arr = GPBUtil::checkMapField($var, \Google\Protobuf\Internal\GPBType::STRING, \Google\Protobuf\Internal\GPBType::STRING);
        $this->metadata = $arr;

        return $this;
    }

    /**
     * Output only. Endpoints associated with this service. Returned on LookupService.Resolve.
     * Control plane clients should use RegistrationService.ListEndpoints.
     *
     * Generated from protobuf field <code>repeated .google.cloud.servicedirectory.v1beta1.Endpoint endpoints = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getEndpoints()
    {
        return $this->endpoints;
    }

    /**
     * Output only. Endpoints associated with this service. Returned on LookupService.Resolve.
     * Control plane clients should use RegistrationService.ListEndpoints.
     *
     * Generated from protobuf field <code>repeated .google.cloud.servicedirectory.v1beta1.Endpoint endpoints = 3 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param \Google\Cloud\ServiceDirectory\V1beta1\Endpoint[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setEndpoints($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\ServiceDirectory\V1beta1\Endpoint::class);
        $this->endpoints = $arr;

        return $this;
    }

}

