<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/talent/v4/job_service.proto

namespace Google\Cloud\Talent\V4;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Request to delete a batch of jobs.
 *
 * Generated from protobuf message <code>google.cloud.talent.v4.BatchDeleteJobsRequest</code>
 */
class BatchDeleteJobsRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required. The resource name of the tenant under which the job is created.
     * The format is "projects/{project_id}/tenants/{tenant_id}". For example,
     * "projects/foo/tenants/bar".
     * The parent of all of the jobs specified in `names` must match this field.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     */
    private $parent = '';
    /**
     * The names of the jobs to delete.
     * The format is "projects/{project_id}/tenants/{tenant_id}/jobs/{job_id}".
     * For example, "projects/foo/tenants/bar/jobs/baz".
     * A maximum of 200 jobs can be deleted in a batch.
     *
     * Generated from protobuf field <code>repeated string names = 2 [(.google.api.resource_reference) = {</code>
     */
    private $names;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required. The resource name of the tenant under which the job is created.
     *           The format is "projects/{project_id}/tenants/{tenant_id}". For example,
     *           "projects/foo/tenants/bar".
     *           The parent of all of the jobs specified in `names` must match this field.
     *     @type string[]|\Google\Protobuf\Internal\RepeatedField $names
     *           The names of the jobs to delete.
     *           The format is "projects/{project_id}/tenants/{tenant_id}/jobs/{job_id}".
     *           For example, "projects/foo/tenants/bar/jobs/baz".
     *           A maximum of 200 jobs can be deleted in a batch.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Talent\V4\JobService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required. The resource name of the tenant under which the job is created.
     * The format is "projects/{project_id}/tenants/{tenant_id}". For example,
     * "projects/foo/tenants/bar".
     * The parent of all of the jobs specified in `names` must match this field.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required. The resource name of the tenant under which the job is created.
     * The format is "projects/{project_id}/tenants/{tenant_id}". For example,
     * "projects/foo/tenants/bar".
     * The parent of all of the jobs specified in `names` must match this field.
     *
     * Generated from protobuf field <code>string parent = 1 [(.google.api.field_behavior) = REQUIRED, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * The names of the jobs to delete.
     * The format is "projects/{project_id}/tenants/{tenant_id}/jobs/{job_id}".
     * For example, "projects/foo/tenants/bar/jobs/baz".
     * A maximum of 200 jobs can be deleted in a batch.
     *
     * Generated from protobuf field <code>repeated string names = 2 [(.google.api.resource_reference) = {</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getNames()
    {
        return $this->names;
    }

    /**
     * The names of the jobs to delete.
     * The format is "projects/{project_id}/tenants/{tenant_id}/jobs/{job_id}".
     * For example, "projects/foo/tenants/bar/jobs/baz".
     * A maximum of 200 jobs can be deleted in a batch.
     *
     * Generated from protobuf field <code>repeated string names = 2 [(.google.api.resource_reference) = {</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setNames($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->names = $arr;

        return $this;
    }

}

