<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/talent/v4beta1/filters.proto

namespace Google\Cloud\Talent\V4beta1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Education filter of the search.
 *
 * Generated from protobuf message <code>google.cloud.talent.v4beta1.EducationFilter</code>
 */
class EducationFilter extends \Google\Protobuf\Internal\Message
{
    /**
     * The school name. For example "MIT", "University of California, Berkeley".
     *
     * Generated from protobuf field <code>string school = 1;</code>
     */
    private $school = '';
    /**
     * The field of study. This is to search against value provided in
     * [Degree.fields_of_study][google.cloud.talent.v4beta1.Degree.fields_of_study].
     * For example "Computer Science", "Mathematics".
     *
     * Generated from protobuf field <code>string field_of_study = 2;</code>
     */
    private $field_of_study = '';
    /**
     * Education degree in ISCED code. Each value in degree covers a specific
     * level of education, without any expansion to upper nor lower levels of
     * education degree.
     *
     * Generated from protobuf field <code>.google.cloud.talent.v4beta1.DegreeType degree_type = 3;</code>
     */
    private $degree_type = 0;
    /**
     * Whether to apply negation to the filter so profiles matching the filter
     * is excluded.
     *
     * Generated from protobuf field <code>bool negated = 6;</code>
     */
    private $negated = false;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $school
     *           The school name. For example "MIT", "University of California, Berkeley".
     *     @type string $field_of_study
     *           The field of study. This is to search against value provided in
     *           [Degree.fields_of_study][google.cloud.talent.v4beta1.Degree.fields_of_study].
     *           For example "Computer Science", "Mathematics".
     *     @type int $degree_type
     *           Education degree in ISCED code. Each value in degree covers a specific
     *           level of education, without any expansion to upper nor lower levels of
     *           education degree.
     *     @type bool $negated
     *           Whether to apply negation to the filter so profiles matching the filter
     *           is excluded.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Talent\V4Beta1\Filters::initOnce();
        parent::__construct($data);
    }

    /**
     * The school name. For example "MIT", "University of California, Berkeley".
     *
     * Generated from protobuf field <code>string school = 1;</code>
     * @return string
     */
    public function getSchool()
    {
        return $this->school;
    }

    /**
     * The school name. For example "MIT", "University of California, Berkeley".
     *
     * Generated from protobuf field <code>string school = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setSchool($var)
    {
        GPBUtil::checkString($var, True);
        $this->school = $var;

        return $this;
    }

    /**
     * The field of study. This is to search against value provided in
     * [Degree.fields_of_study][google.cloud.talent.v4beta1.Degree.fields_of_study].
     * For example "Computer Science", "Mathematics".
     *
     * Generated from protobuf field <code>string field_of_study = 2;</code>
     * @return string
     */
    public function getFieldOfStudy()
    {
        return $this->field_of_study;
    }

    /**
     * The field of study. This is to search against value provided in
     * [Degree.fields_of_study][google.cloud.talent.v4beta1.Degree.fields_of_study].
     * For example "Computer Science", "Mathematics".
     *
     * Generated from protobuf field <code>string field_of_study = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setFieldOfStudy($var)
    {
        GPBUtil::checkString($var, True);
        $this->field_of_study = $var;

        return $this;
    }

    /**
     * Education degree in ISCED code. Each value in degree covers a specific
     * level of education, without any expansion to upper nor lower levels of
     * education degree.
     *
     * Generated from protobuf field <code>.google.cloud.talent.v4beta1.DegreeType degree_type = 3;</code>
     * @return int
     */
    public function getDegreeType()
    {
        return $this->degree_type;
    }

    /**
     * Education degree in ISCED code. Each value in degree covers a specific
     * level of education, without any expansion to upper nor lower levels of
     * education degree.
     *
     * Generated from protobuf field <code>.google.cloud.talent.v4beta1.DegreeType degree_type = 3;</code>
     * @param int $var
     * @return $this
     */
    public function setDegreeType($var)
    {
        GPBUtil::checkEnum($var, \Google\Cloud\Talent\V4beta1\DegreeType::class);
        $this->degree_type = $var;

        return $this;
    }

    /**
     * Whether to apply negation to the filter so profiles matching the filter
     * is excluded.
     *
     * Generated from protobuf field <code>bool negated = 6;</code>
     * @return bool
     */
    public function getNegated()
    {
        return $this->negated;
    }

    /**
     * Whether to apply negation to the filter so profiles matching the filter
     * is excluded.
     *
     * Generated from protobuf field <code>bool negated = 6;</code>
     * @param bool $var
     * @return $this
     */
    public function setNegated($var)
    {
        GPBUtil::checkBool($var);
        $this->negated = $var;

        return $this;
    }

}

