<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/talent/v4beta1/resume_service.proto

namespace Google\Cloud\Talent\V4beta1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Parse resume request.
 *
 * Generated from protobuf message <code>google.cloud.talent.v4beta1.ParseResumeRequest</code>
 */
class ParseResumeRequest extends \Google\Protobuf\Internal\Message
{
    /**
     * Required.
     * The resource name of the project.
     * The format is "projects/{project_id}", for example,
     * "projects/api-test-project".
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     */
    private $parent = '';
    /**
     * Required.
     * The bytes of the resume file in common format. Currently the API supports
     * the following formats:
     * PDF, TXT, DOC, RTF and DOCX.
     *
     * Generated from protobuf field <code>bytes resume = 2;</code>
     */
    private $resume = '';
    /**
     * Optional.
     * The region code indicating where the resume is from. Values
     * are as per the ISO-3166-2 format. For example, US, FR, DE.
     * This value is optional, but providing this value improves the resume
     * parsing quality and performance.
     * An error is thrown if the regionCode is invalid.
     *
     * Generated from protobuf field <code>string region_code = 3;</code>
     */
    private $region_code = '';
    /**
     * Optional.
     * The language code of contents in the resume.
     * Language codes must be in BCP-47 format, such as "en-US" or "sr-Latn".
     * For more information, see
     * [Tags for Identifying Languages](https://tools.ietf.org/html/bcp47){:
     * class="external" target="_blank" }.
     *
     * Generated from protobuf field <code>string language_code = 4;</code>
     */
    private $language_code = '';

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $parent
     *           Required.
     *           The resource name of the project.
     *           The format is "projects/{project_id}", for example,
     *           "projects/api-test-project".
     *     @type string $resume
     *           Required.
     *           The bytes of the resume file in common format. Currently the API supports
     *           the following formats:
     *           PDF, TXT, DOC, RTF and DOCX.
     *     @type string $region_code
     *           Optional.
     *           The region code indicating where the resume is from. Values
     *           are as per the ISO-3166-2 format. For example, US, FR, DE.
     *           This value is optional, but providing this value improves the resume
     *           parsing quality and performance.
     *           An error is thrown if the regionCode is invalid.
     *     @type string $language_code
     *           Optional.
     *           The language code of contents in the resume.
     *           Language codes must be in BCP-47 format, such as "en-US" or "sr-Latn".
     *           For more information, see
     *           [Tags for Identifying Languages](https://tools.ietf.org/html/bcp47){:
     *           class="external" target="_blank" }.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Talent\V4Beta1\ResumeService::initOnce();
        parent::__construct($data);
    }

    /**
     * Required.
     * The resource name of the project.
     * The format is "projects/{project_id}", for example,
     * "projects/api-test-project".
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * Required.
     * The resource name of the project.
     * The format is "projects/{project_id}", for example,
     * "projects/api-test-project".
     *
     * Generated from protobuf field <code>string parent = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setParent($var)
    {
        GPBUtil::checkString($var, True);
        $this->parent = $var;

        return $this;
    }

    /**
     * Required.
     * The bytes of the resume file in common format. Currently the API supports
     * the following formats:
     * PDF, TXT, DOC, RTF and DOCX.
     *
     * Generated from protobuf field <code>bytes resume = 2;</code>
     * @return string
     */
    public function getResume()
    {
        return $this->resume;
    }

    /**
     * Required.
     * The bytes of the resume file in common format. Currently the API supports
     * the following formats:
     * PDF, TXT, DOC, RTF and DOCX.
     *
     * Generated from protobuf field <code>bytes resume = 2;</code>
     * @param string $var
     * @return $this
     */
    public function setResume($var)
    {
        GPBUtil::checkString($var, False);
        $this->resume = $var;

        return $this;
    }

    /**
     * Optional.
     * The region code indicating where the resume is from. Values
     * are as per the ISO-3166-2 format. For example, US, FR, DE.
     * This value is optional, but providing this value improves the resume
     * parsing quality and performance.
     * An error is thrown if the regionCode is invalid.
     *
     * Generated from protobuf field <code>string region_code = 3;</code>
     * @return string
     */
    public function getRegionCode()
    {
        return $this->region_code;
    }

    /**
     * Optional.
     * The region code indicating where the resume is from. Values
     * are as per the ISO-3166-2 format. For example, US, FR, DE.
     * This value is optional, but providing this value improves the resume
     * parsing quality and performance.
     * An error is thrown if the regionCode is invalid.
     *
     * Generated from protobuf field <code>string region_code = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setRegionCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->region_code = $var;

        return $this;
    }

    /**
     * Optional.
     * The language code of contents in the resume.
     * Language codes must be in BCP-47 format, such as "en-US" or "sr-Latn".
     * For more information, see
     * [Tags for Identifying Languages](https://tools.ietf.org/html/bcp47){:
     * class="external" target="_blank" }.
     *
     * Generated from protobuf field <code>string language_code = 4;</code>
     * @return string
     */
    public function getLanguageCode()
    {
        return $this->language_code;
    }

    /**
     * Optional.
     * The language code of contents in the resume.
     * Language codes must be in BCP-47 format, such as "en-US" or "sr-Latn".
     * For more information, see
     * [Tags for Identifying Languages](https://tools.ietf.org/html/bcp47){:
     * class="external" target="_blank" }.
     *
     * Generated from protobuf field <code>string language_code = 4;</code>
     * @param string $var
     * @return $this
     */
    public function setLanguageCode($var)
    {
        GPBUtil::checkString($var, True);
        $this->language_code = $var;

        return $this;
    }

}

