<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/cloud/talent/v4beta1/profile.proto

namespace Google\Cloud\Talent\V4beta1;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Resource that represents the patent acquired by a candidate.
 *
 * Generated from protobuf message <code>google.cloud.talent.v4beta1.Patent</code>
 */
class Patent extends \Google\Protobuf\Internal\Message
{
    /**
     * Name of the patent.
     * Number of characters allowed is 100.
     *
     * Generated from protobuf field <code>string display_name = 1;</code>
     */
    private $display_name = '';
    /**
     * A list of inventors' names.
     * Number of characters allowed for each is 100.
     *
     * Generated from protobuf field <code>repeated string inventors = 2;</code>
     */
    private $inventors;
    /**
     * The status of the patent.
     * Number of characters allowed is 100.
     *
     * Generated from protobuf field <code>string patent_status = 3;</code>
     */
    private $patent_status = '';
    /**
     * The date the last time the status of the patent was checked.
     *
     * Generated from protobuf field <code>.google.type.Date patent_status_date = 4;</code>
     */
    private $patent_status_date = null;
    /**
     * The date that the patent was filed.
     *
     * Generated from protobuf field <code>.google.type.Date patent_filing_date = 5;</code>
     */
    private $patent_filing_date = null;
    /**
     * The name of the patent office.
     * Number of characters allowed is 100.
     *
     * Generated from protobuf field <code>string patent_office = 6;</code>
     */
    private $patent_office = '';
    /**
     * The number of the patent.
     * Number of characters allowed is 100.
     *
     * Generated from protobuf field <code>string patent_number = 7;</code>
     */
    private $patent_number = '';
    /**
     * The description of the patent.
     * Number of characters allowed is 100,000.
     *
     * Generated from protobuf field <code>string patent_description = 8;</code>
     */
    private $patent_description = '';
    /**
     * The skills used in this patent.
     *
     * Generated from protobuf field <code>repeated .google.cloud.talent.v4beta1.Skill skills_used = 9;</code>
     */
    private $skills_used;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $display_name
     *           Name of the patent.
     *           Number of characters allowed is 100.
     *     @type string[]|\Google\Protobuf\Internal\RepeatedField $inventors
     *           A list of inventors' names.
     *           Number of characters allowed for each is 100.
     *     @type string $patent_status
     *           The status of the patent.
     *           Number of characters allowed is 100.
     *     @type \Google\Type\Date $patent_status_date
     *           The date the last time the status of the patent was checked.
     *     @type \Google\Type\Date $patent_filing_date
     *           The date that the patent was filed.
     *     @type string $patent_office
     *           The name of the patent office.
     *           Number of characters allowed is 100.
     *     @type string $patent_number
     *           The number of the patent.
     *           Number of characters allowed is 100.
     *     @type string $patent_description
     *           The description of the patent.
     *           Number of characters allowed is 100,000.
     *     @type \Google\Cloud\Talent\V4beta1\Skill[]|\Google\Protobuf\Internal\RepeatedField $skills_used
     *           The skills used in this patent.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Cloud\Talent\V4Beta1\Profile::initOnce();
        parent::__construct($data);
    }

    /**
     * Name of the patent.
     * Number of characters allowed is 100.
     *
     * Generated from protobuf field <code>string display_name = 1;</code>
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }

    /**
     * Name of the patent.
     * Number of characters allowed is 100.
     *
     * Generated from protobuf field <code>string display_name = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setDisplayName($var)
    {
        GPBUtil::checkString($var, True);
        $this->display_name = $var;

        return $this;
    }

    /**
     * A list of inventors' names.
     * Number of characters allowed for each is 100.
     *
     * Generated from protobuf field <code>repeated string inventors = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getInventors()
    {
        return $this->inventors;
    }

    /**
     * A list of inventors' names.
     * Number of characters allowed for each is 100.
     *
     * Generated from protobuf field <code>repeated string inventors = 2;</code>
     * @param string[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setInventors($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::STRING);
        $this->inventors = $arr;

        return $this;
    }

    /**
     * The status of the patent.
     * Number of characters allowed is 100.
     *
     * Generated from protobuf field <code>string patent_status = 3;</code>
     * @return string
     */
    public function getPatentStatus()
    {
        return $this->patent_status;
    }

    /**
     * The status of the patent.
     * Number of characters allowed is 100.
     *
     * Generated from protobuf field <code>string patent_status = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setPatentStatus($var)
    {
        GPBUtil::checkString($var, True);
        $this->patent_status = $var;

        return $this;
    }

    /**
     * The date the last time the status of the patent was checked.
     *
     * Generated from protobuf field <code>.google.type.Date patent_status_date = 4;</code>
     * @return \Google\Type\Date
     */
    public function getPatentStatusDate()
    {
        return isset($this->patent_status_date) ? $this->patent_status_date : null;
    }

    public function hasPatentStatusDate()
    {
        return isset($this->patent_status_date);
    }

    public function clearPatentStatusDate()
    {
        unset($this->patent_status_date);
    }

    /**
     * The date the last time the status of the patent was checked.
     *
     * Generated from protobuf field <code>.google.type.Date patent_status_date = 4;</code>
     * @param \Google\Type\Date $var
     * @return $this
     */
    public function setPatentStatusDate($var)
    {
        GPBUtil::checkMessage($var, \Google\Type\Date::class);
        $this->patent_status_date = $var;

        return $this;
    }

    /**
     * The date that the patent was filed.
     *
     * Generated from protobuf field <code>.google.type.Date patent_filing_date = 5;</code>
     * @return \Google\Type\Date
     */
    public function getPatentFilingDate()
    {
        return isset($this->patent_filing_date) ? $this->patent_filing_date : null;
    }

    public function hasPatentFilingDate()
    {
        return isset($this->patent_filing_date);
    }

    public function clearPatentFilingDate()
    {
        unset($this->patent_filing_date);
    }

    /**
     * The date that the patent was filed.
     *
     * Generated from protobuf field <code>.google.type.Date patent_filing_date = 5;</code>
     * @param \Google\Type\Date $var
     * @return $this
     */
    public function setPatentFilingDate($var)
    {
        GPBUtil::checkMessage($var, \Google\Type\Date::class);
        $this->patent_filing_date = $var;

        return $this;
    }

    /**
     * The name of the patent office.
     * Number of characters allowed is 100.
     *
     * Generated from protobuf field <code>string patent_office = 6;</code>
     * @return string
     */
    public function getPatentOffice()
    {
        return $this->patent_office;
    }

    /**
     * The name of the patent office.
     * Number of characters allowed is 100.
     *
     * Generated from protobuf field <code>string patent_office = 6;</code>
     * @param string $var
     * @return $this
     */
    public function setPatentOffice($var)
    {
        GPBUtil::checkString($var, True);
        $this->patent_office = $var;

        return $this;
    }

    /**
     * The number of the patent.
     * Number of characters allowed is 100.
     *
     * Generated from protobuf field <code>string patent_number = 7;</code>
     * @return string
     */
    public function getPatentNumber()
    {
        return $this->patent_number;
    }

    /**
     * The number of the patent.
     * Number of characters allowed is 100.
     *
     * Generated from protobuf field <code>string patent_number = 7;</code>
     * @param string $var
     * @return $this
     */
    public function setPatentNumber($var)
    {
        GPBUtil::checkString($var, True);
        $this->patent_number = $var;

        return $this;
    }

    /**
     * The description of the patent.
     * Number of characters allowed is 100,000.
     *
     * Generated from protobuf field <code>string patent_description = 8;</code>
     * @return string
     */
    public function getPatentDescription()
    {
        return $this->patent_description;
    }

    /**
     * The description of the patent.
     * Number of characters allowed is 100,000.
     *
     * Generated from protobuf field <code>string patent_description = 8;</code>
     * @param string $var
     * @return $this
     */
    public function setPatentDescription($var)
    {
        GPBUtil::checkString($var, True);
        $this->patent_description = $var;

        return $this;
    }

    /**
     * The skills used in this patent.
     *
     * Generated from protobuf field <code>repeated .google.cloud.talent.v4beta1.Skill skills_used = 9;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSkillsUsed()
    {
        return $this->skills_used;
    }

    /**
     * The skills used in this patent.
     *
     * Generated from protobuf field <code>repeated .google.cloud.talent.v4beta1.Skill skills_used = 9;</code>
     * @param \Google\Cloud\Talent\V4beta1\Skill[]|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSkillsUsed($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Cloud\Talent\V4beta1\Skill::class);
        $this->skills_used = $arr;

        return $this;
    }

}

